/* defense.h
 */
#ifndef _CATEGORY_DEFENSE_H
#define _CATEGORY_DEFENSE_H

#include "osl/category/categoryTraits.h"
#include "osl/category/ptypePtypeProbTable.h"
#include "osl/category/categoryEnv.h"
#include "osl/move_classifier/blockLongEffect.h"
#include "osl/move_classifier/moveAdaptor.h"

namespace osl
{
  namespace category
  {
    /**
     * դƼ
     */
    struct AddSupport : public TableProbabilityCategory
    {
      static Interpolator<PtypePtypeProbTable> probTable;
      static const char *getName() { return "AddSupport"; }
      struct Test;
      static std::pair<bool,size_t> 
      getIndexIf(const CategoryEnv& env, Move move, int pieceValue);
      template <Player P>
      static std::pair<bool,size_t> 
      getIndexIfByPlayer(const CategoryEnv& env, Move move, int pieceValue);
    };

    /**
     * ʤɤĤƼ
     */
    struct AddEffectToLastEffect : public StandardProbabilityCategory
    {
      static Interpolator<PieceValueTable> probTable;
      static const char *getName() { return "AddEffectToLastEffect"; }
      struct CheckEffect;
      static bool isInCategory(const CategoryEnv& env, Move move);
    };

    /**
     * ɤ
     */
    struct AntiPromotion : public StandardProbabilityCategory
    {
      static Interpolator<PieceValueTable> probTable; // 650; 
      static const char *getName() { return "AntiPromotion"; }
      struct Test;
      static bool isInCategory(const CategoryEnv& env, Move move);
    };
    
    /**
     * ߤ
     */
    struct BlockLong : public StandardProbabilityCategory
    {
      static Interpolator<PieceValueTable> probTable;
      static const char *getName() { return "BlockLong"; }
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	return move_classifier::PlayerMoveAdaptor<move_classifier::BlockLongAny>
	  ::isMember(*env.state, move);
      }
    };
  } // namespace category
} // namespace oslb


#endif /* _CATEGORY_DEFENSE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
