/* indexUtil.h
 */
#ifndef OSL_CATEGORY_INDEXUTIL_H
#define OSL_CATEGORY_INDEXUTIL_H

#include "osl/category/categoryUtil.h"
#include "osl/move_classifier/safeMove.h"

namespace osl
{
  namespace category
  {
    /**
     * index Ĥ. ǤϤĤ鷺Ψ¬ΤߤѤ륳
     */
    template <class Category> 
    struct IndexUtil : CategoryUtilBase
    {
    private:
      static void doNotCompile();	// not implemented;
    private:
      static void generateWithIndex(const CategoryEnv&, MoveLogProbVector&,
				    int *, Int2Type<SPECIAL>)
      {
	doNotCompile();
      }
      static void generateWithIndex(const CategoryEnv& env, 
				    MoveLogProbVector& out, int *indices,
				    Int2Type<TABLE>)
      {
	Category::generate(env, out, indices);
	out.sortByProbability();
      }
      static void generateWithIndex(const CategoryEnv& env, 
				    MoveLogProbVector& out, int *indices,
				    Int2Type<STANDARD_TABLE>)
      {
	MoveVector moves;
	Category::generate(env, moves);
	using namespace move_classifier;
	for (MoveVector::const_iterator p=moves.begin(); p!=moves.end(); ++p)
	{
	  if (! ConditionAdaptor<SafeMove>::isMember(*env.state, *p))
	    continue;

	  const int diff = MoveEvaluation::evalLight(*env.state, *p);
	  const size_t index = Category::getIndex(env, *p, diff);
	  const int moveProb = Category::probTable[index];
	  if (moveProb <= env.limit) 
	  {
	    *indices++ = index;
	    out.push_back(*p, moveProb);
	  }
	}
	out.sortByProbability();
      }
      static void generateWithIndex(const CategoryEnv& env, 
				    MoveLogProbVector& out, int *indices,
				    Int2Type<FIXED>)
      {
	using namespace move_classifier;
	assert(env.limit >= Category::probTable[0]);
	MoveVector moves;
	Category::generate(env, moves);
	for (MoveVector::const_iterator p=moves.begin(); p!=moves.end(); ++p)
	{
	  if (! ConditionAdaptor<SafeMove>::isMember(*env.state, *p))
	    continue;

	  out.push_back(*p, Category::probTable[0]);
	  *indices++ = 0;
	}
	// no need to sort here
      }
    public:
      /**
       * ƥ Category ˻ؼindex 
       * Ψ¬
       * 
       * ƥ˻Ѳǽ
       */
      static void generateWithIndex(const CategoryEnv& env, 
				    MoveLogProbVector& out, int *indices)
      {
	generateWithIndex(env, out, indices, Int2Type<Category::probType>());
      }
    };
  }
}

#endif /* OSL_CATEGORY_INDEXUTIL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
