/* kingEscape.h
 */
#ifndef CATEGORY_KINGESCAPE_H
#define CATEGORY_KINGESCAPE_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/move_generator/escape.h"
#include "osl/move_action/store.h"
#include "osl/container/moveStack.h"
#include "osl/effect_util/neighboring8Direct.h"
#include "osl/neighboring8.h"
namespace osl
{
  namespace category
  {
    /**
     * ˲꤬äƤȤƨ
     */
    struct KingEscape : public StandardProbabilityCategory
    {
      static Interpolator<PieceValueTable> probTable;
      static const char *getName() { return "KingEscape"; }
      static const bool IsKingEscape = true;
      static void generate(const CategoryEnv& env, MoveVector& out)
      {
	const Player player = env.state->getTurn();
	const Piece kingPiece=env.state->getKingPiece(player);
	const Position kingPosition=kingPiece.position();
	/**
	 * ̤ʤƤפˤ
	 */
	if (kingPosition.isPieceStand()) return;
	if (! env.state->hasEffectBy(alt(player), kingPosition))
	  return;

	move_action::Store store(out);
	assert(kingPiece == (*env.state).getPieceAt(kingPosition));
	if (player == BLACK)
	  move_generator::Escape<BLACK,CategoryEnv::effect_state_t,move_action::Store>::
	    generateMoves(*env.state,kingPiece,store);
	else
	  move_generator::Escape<WHITE,CategoryEnv::effect_state_t,move_action::Store>::
	    generateMoves(*env.state,kingPiece,store);
      }
    };

    /**
     * 
     */
    struct EnteringKing : public FixedProbabilityCategory
    {
      static FixedValueTable probTable; // 700;
      static const char *getName() { return "EnteringKing"; }

      static bool isInCategory(const CategoryEnv& /*env*/, Move move)
      {
	return (move.ptype() == KING)
	  && move.to().canPromote(move.player());
      }
    };

    /**
     * ư(dropޤ)ξ꤫ư𤬼̤8˵
     * ⤷8˵Ǥ
     */
    struct DirectDefenseToKing8 : public StandardProbabilityCategory
    {
      static Interpolator<PieceValueTable> probTable; // { return 800; }
      static const char *getName() { return "DirectDefenseToKing8"; }
    public:
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	const PtypeO ptypeo = move.ptypeO();
	const Position to = move.to();
	const Position kingPosition =
	  env.state->getKingPosition(env.state->getTurn());
	return Neighboring8::isNeighboring8(move.to(),kingPosition)
	  || Neighboring8Direct::hasEffect(*env.state, ptypeo, 
					   to, kingPosition);
      }
    };
    
  } // namespace category
} // namespace osl

#endif /* _KINGESCAPE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
