/* standardMoveGenerator.h
 */
#ifndef _STANDARD_MOVE_GENERATOR_H
#define _STANDARD_MOVE_GENERATOR_H

#include "osl/category/categoryList.h"
#include "osl/category/takeBack.h"
#include "osl/category/check.h"
#include "osl/category/kingEscape.h"
#include "osl/category/capture.h"
#include "osl/category/addEffect.h"
#include "osl/category/promote.h"
#include "osl/category/escape.h"
#include "osl/category/defense.h"
#include "osl/category/ptypePosition.h"
#include "osl/category/pawn.h"
#include "osl/category/lance.h"
#include "osl/category/silver.h"
#include "osl/category/mate.h"
#include "osl/category/bigramPosition.h"
#include "osl/category/classify.h"
#include "osl/category/pass.h"
#include "osl/category/gold.h"
#include "osl/category/majorPiece.h"
#include "osl/category/knight.h"
#include "osl/category/breakThreatmate.h"

#define CL(x,y) CategoryList<x,y >
namespace osl
{
  namespace category
  {
    /**
     * StandardMoveGenerator ǻȤƥΰ.
     * Ψۤɹ⤯ʤޤȤƺäƤʬह륫ƥ
     */
    typedef 
    Classify<
      CL(OpenAttack,
	 CL(Escape<GOLD>,
	    CL(Escape<SILVER>,
	       CL(Capture<PAWN>,
		  CL(AddEffectToLastEffect,
		     CL(StabInTheBack,
			CL(Promote,
			   CL(KnightDoubleAttack,
			      CL(SideAttack,
				 CL(SideAttackDrop,
				    CL(AddEffect,
				       CL(OpenBishop,
					  CL(AddSupport,
					     CL(RookAddPawnSupport,
						CL(LureKingToBottom,
						   CL(LanceAttackMinoGold,
						      CL(KnightToAttack,
							 CL(JoiningKnights,
							    CL(RookAddLanceSupport,
							       CL(DirectAttackToKing8,
								  CL(PrepareRookPromotion,
								     CL(DirectDefenseToKing8,
									CL(SilverHeadOfKnight,
									   CL(SlowApproach,
									      CL(LureGoldDiagonally,
										 CL(PrepareForkGold,
										    CL(BlockLong,
										       CL(TrapRook,
											  CL(DanglingPawn,
											     CL(GambitPawn,
												CL(PawnAttackBase,
												   CL(MoveSaGWithPawn,
												      CL(LanceAttackKing,
													 CL(LanceSacrifice,
													    CL(KnightAttackYagura,
													       CL(SilverNextToKing,

														  CL(Escape<KNIGHT>,
														     CL(Escape<LANCE>,
															CL(PawnStopBishopEffect,
															   CL(PawnOnSilver,
															      CL(PawnOnLance,
																 CL(Escape<PAWN>,
																    CL(AntiPromotion,
																       CL(AnchorPawn,
																	  CL(ForwardPawnWithRookSupport,
																	     CL(DropPieceOnEscapeRoute,
																		CL(ForcePawnAdvanceOnRook,
																		   CL(EnteringKing,
																		      CL(PtypePosition,
																			 NullCategory
																			 )))))))))))))))))))))))))))))))))))))))))))))))))>
    StandardClassifier_t;
    struct StandardClassifier : public StandardClassifier_t
    {
    };
    /**
     * ΨõǻȤ MoveGenerator
     *
     * Ψ¬äƱ֤ݤɬפ뤳Ȥ
     */
    typedef 
    CL(KingEscape, 
     CL(BreakThreatmate,
       CL(TakeBack, 
	  CL(Capture<ROOK>,
	     CL(ContinueCapture,
		CL(Capture<BISHOP>,
		   CL(ImmediateEscape,
		      CL(ImmediateAntiPawnPromotion,
			 CL(Pass,
			    CL(BigramAttack,
			       CL(JoiningPawns,
				  CL(DropAfterOpposingPawn,
				     CL(SilverHeadOfLastKnight,
					CL(Check,
					   CL(Escape<ROOK>,
					      CL(Escape<BISHOP>,
						 CL(Capture<GOLD>,
						    CL(Capture<SILVER>,
						       CL(Capture<KNIGHT>,
							  CL(Capture<LANCE>,
							     CL(AddEffectToLastMove,
								CL(SafeDropMajorPiece,
								   CL(StandardClassifier,
								      NullCategory
								     )))))))))))))))))))))))
      StandardMoveGenerator_t;
    struct StandardMoveGenerator : public StandardMoveGenerator_t
    {
    };
  } // namespace category

  using category::StandardMoveGenerator;

} // namespace osl
#undef CL

#endif /* _STANDARD_MOVE_GENERATOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
