/* takeBack.h
 */
#ifndef _TAKEBACK_H
#define _TAKEBACK_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/category/probTable.h"
#include "osl/move_generator/capture.h"
#include "osl/move_action/store.h"
#include "osl/container/moveStack.h"

namespace osl
{
  namespace category
  {
    /**
     * ֤
     */
    struct TakeBack : public StandardProbabilityCategory
    {
      static Interpolator<PieceValueTable> probTable;
      static const char *getName() { return "TakeBack"; }
      static bool isEffective(const CategoryEnv& env)
      {
	return env.history->lastMove().isNormal();
      }
      static bool isInCategory(const CategoryEnv& env, Move move)
      {
	return isEffective(env) 
	  && (env.history->lastMove().to() == move.to());
      }
      static void generate(const CategoryEnv& env, MoveVector& out)
      {
	if (! isEffective(env))
	  return;
	move_action::Store store(out);
	move_generator::GenerateCapture::
	  generate(env.state->getTurn(), *env.state, 
		   env.history->lastMove().to(), store);
      }
    };

  } // namespace category
} // namespace osl

#endif /* _TAKEBACK_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
