/* king8Info.h
 */
#ifndef OSL_CHECKMATE_KING8INFO_H
#define OSL_CHECKMATE_KING8INFO_H

#include "osl/state/numEffectState.h"
#include "osl/misc/bitOp.h"
#include <iosfwd>
namespace osl
{
  namespace checkmate
  {
    /**
     * Ṳ̃8˵ξ֤ɽ.
     * Dirζ̤ФDirǲ򤫤
     * 0-7 : Ṵ̃ʳʤʬ
     *       (ǤĸȤʤꤦ)
     * 8-15 : Ṳ̃Dir˰ưǽ
     * 16-23 : ̣ζ(Ǥϰưǽˤʤ)
     * 24-31 : Ṵ̃ʳʤʬ2İʾ夢Ũ
     *       (ưȤʤꤦ)
     */
    struct King8Info
    {
      unsigned int value;
      explicit King8Info(unsigned int v) : value(v)
      {
      }

      template<Player P>
      static const King8Info make(NumEffectState const& state,Position king,PieceMask pinned);
      template<Player P>
      static const King8Info make(NumEffectState const& state,Position king);
      template<Player P>
      static const King8Info makeAndSetPin(NumEffectState const& state,Position king,
					   PieceMask& out);
      /** alt(attack) king ˤĤƷ׻ */
      static const King8Info make(Player attack, NumEffectState const& state);
      /** alt(attack) king ˤĤƷ׻. Ѥpin */
      static const King8Info makeAndSetPin(Player attack, NumEffectState const& state,
					   PieceMask& pins);

      /** 0-7 bit ܤ֤ */
      unsigned int dropCandidate() const
      {
	return value&0xff;
      }
      /** 8-15 bit ܤ 0-7bitshift֤ */
      unsigned int liberty() const
      {
	return (value>>8)&0xff;
      }
      unsigned int libertyCount() const
      {
	return misc::BitOp::countBit(liberty());
      }
      /** 0-15bit */
      unsigned int libertyDropMask() const
      {
	return value&0xffff;
      }
      /** 16-23 bit ܤ 0-7bitshift֤ */
      unsigned int libertyCandidate() const
      {
	return (value>>16)&0xff;
      }
      /** 24-31 bit ܤ 0-7bitshift֤ */
      unsigned int moveCandidate() const
      {
	return (value>>24)&0xff;
      }
    private:
      /**
       * alt(P)ζ̤DircanMoveMask׻.
       * @param P(template) - ¦player
       * @param Dir(template) - Ṳ̃(short8)
       * @param state - 
       * @param target - alt(P)ζ̤potision
       */
      template<Player P,Direction Dir>
      static unsigned int hasEffectMask(NumEffectState const& state,Position target,PieceMask pinned);
    };

    std::ostream& operator<<(std::ostream&, King8Info);
  } // namespace checkmate
  using checkmate::King8Info;
} // namespace osl

#endif /* OSL_CHECKMATE_KING8INFO_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:

