/* twinEntry.h
 */
#ifndef _TWINENTRY_H
#define _TWINENTRY_H

#include "osl/checkmate/checkMove.h"
#include "osl/pathEncoding.h"

namespace osl
{
  namespace checkmate
  {
    class CheckHashRecord;
    struct TwinEntry
    {
      PathEncoding path;
      CheckMoveCore move;
      /**
       * loopΥɥ쥹ʣ0.
       * LoopDetection  NoCheckmate ڤؤ뤿˻
       */
      const CheckHashRecord *loopTo;
      TwinEntry(const PathEncoding& p, const CheckMoveCore& m,
		const CheckHashRecord *l=0)
	: path(p), move(m), loopTo(l)
      {
      }
    };

    /**
     * Ʊߥ졼2ٹԤʤʤεϿȡTwinEntryƱɽ˳Ǽ뤿Υ饹.
     * - LoopDetectionȯ -> TwinEntry 
     * - LoopDetection̤ȯ -> TwinEntry::path  age 
     */
    struct TwinAgeEntry
    {
      TwinEntry entry;
      /**
       * 󥷥ߥ졼󤷤twinsĹ
       */
      int age;
      /**
       * TwinEntry 
       */
      TwinAgeEntry(const PathEncoding& p, const CheckMoveCore& m,
		   const CheckHashRecord *l=0)
	: entry(p, m, l), age(-1)
      {
      }
      /**
       * age 
       */
      TwinAgeEntry(const PathEncoding& path) : entry(path, CheckMoveCore()), age(0)
      {
      }
      bool hasTwinEntry() const { return age < 0; }
      void setTwinEntry(const TwinEntry& e) 
      {
	assert(entry.path == e.path);
	entry.move = e.move;
	age = -1;
      }
    };

  } // namespace checkmate
} // namespace osl


#endif /* _TWINENTRY_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
