/* liberty8.h
 */
#ifndef _LIBERTY8_H
#define _LIBERTY8_H

#include "osl/effect/liberty8Table.h"
#include "osl/direction.h"
#include "osl/piece.h"
#include "osl/ptypeList.h"
#include "osl/container/nearMask.h"
#include <boost/type_traits.hpp>
#include <iosfwd>
namespace osl
{
  namespace effect
  {
    /**
     * Liberty8ǻȤHelper.
     * P defense¦
     */
    template<typename Liberty,typename State,Player P,Ptype T>
    class AddMaskAction{
      Liberty & liberty;
      State const& state;
      const Position target;
      const NearMask nearMask;
    public:
      AddMaskAction(Liberty& l,State const& s,Position t,NearMask n) 
	: liberty(l), state(s), target(t), nearMask(n)
      {
      }
      void operator()(Piece p){
#if 1
	const Position from=p.position();
	const NearMask shortMask = Liberty8_Table.
	  getShortMask<PlayerTraits<P>::opponent>(p.ptype(), from, target);
	liberty.andMask(shortMask);
	if(PtypeFuns<T>::hasLongMove &&
	   (T!=LANCE || !p.isPromotedNotKingGold())){
	  LongEffect8 longEffect8=
	    Liberty8_Table.
	    getLongEffect<PlayerTraits<P>::opponent>(p.ptype(),
						     p.position(),
						     target);
	  Offset offset=longEffect8.getOffset();
	  if(offset.zero()) return;
	  // 줬ɤɤޤˤʤ
	  if(state.isEmptyBetween(from,target-offset.blackOffset<P>())){
	    unsigned int nearMaskSpace=nearMask.spaceMask();
	    unsigned int mask0=longEffect8.getMask(0);
	    liberty.andMask(NearMask::makeDirect(~mask0));
	    if((mask0&nearMaskSpace)!=0){
	      unsigned int mask1=longEffect8.getMask(1);
	      liberty.andMask(NearMask::makeDirect(~mask1));
	      if( T!=BISHOP && (mask1&nearMaskSpace)!=0){
		unsigned int mask2=longEffect8.getMask(2);
		liberty.andMask(NearMask::makeDirect(~mask2));
	      }
	    }
	  }
	}
	if(T==ROOK){
	  LongEffect8 longEffect8=
	    Liberty8_Table.
	    getLongEffect2<PlayerTraits<P>::opponent>(p.position(),
						      target);
	  unsigned int mask0=longEffect8.getMask(0);
	  if(mask0==0) return;
	  unsigned int nearMaskSpace=nearMask.spaceMask();
	  liberty.andMask(NearMask::makeDirect(~mask0));
	  if((mask0&nearMaskSpace)==0) return;
	  unsigned int mask1=longEffect8.getMask(1);
	  liberty.andMask(NearMask::makeDirect(~mask1));
	}
#else
	/**
	 * ٤ɤۤȤưС
	 */
	for(int i=0;i<8;i++){
	  Direction dir=static_cast<Direction>(i);
	  Position to=target-Board_Table.getOffset<P>(dir);
	  if(to.isOnBoard() && 
	     state.hasEffectTo(p,to))
	    liberty.andMask(~(1<<i));
	}
	if(state.hasEffectTo(p,target)){
	  Direction longDirection=
	    Board_Table.getLongDirection<P>(target,p.position());
	  // 𤬤ĹäƤ
	  // ĵûäƤ뤳ȤϤʤΤǡ
	  // ɤȤˤ
	  if(Ptype_Table.getMoveMask(p.ptype())&dirToMask(longDirection)){
	    liberty.andMask(~(1<<longToShort(longDirection)));
	  }
	}
#endif      
      }
    };

    /**
     * ʬζ𤬤ޥ8˵Ũξ֤.
     * \li Pߤ, Direction DŨ
     * DirectionTraits<D>::mask ΥӥåȤΩäƤ
     * ħ
     * \li long short϶̤ʤ
     * \li ʬȤˤäƥ֥åƤ뤳Ȥˤ
     */
    template<Player P>
    class Liberty8
    {
      /**
       */
      NearMask mask;
    
      template<typename State,Ptype T>
      void addMaskPtype(State const& state,Position target,NearMask nearMask){
	typedef AddMaskAction<Liberty8<P>,State,P,T> action_t;
	action_t action(*this,state,target,nearMask);
	state.template
	  forEachOnBoard<PlayerTraits<P>::opponent,T,action_t>(action);
      }

      template<typename State,typename U>
      void addMask(State const& state,Position target,NearMask nearMask,U);

      template<typename State>
      void addMask(State const&, Position, NearMask, ptl::NullPtype){}

      template<typename State,Ptype T,typename Tail>
      void addMask(State const& state,Position target,NearMask nearMask,ptl::PtypeList<T,Tail>){
	addMaskPtype<State,T>(state,target,nearMask);
	addMask(state,target,nearMask,Tail());
      }

    public:
      template<typename State>
      Liberty8(State const& state,Position target);
      void andMask(NearMask m){
	mask&=m;
      }
      NearMask getMask() const{
	return mask;
      }
      /**
       * 8 bit Υơ֥Ȥä®׻Ǥ뤬
       */
      int count() const{
	int ret=0;
	for (int i=0;i<8;i++)
	  if (mask.isSet(i))
	    ret++;
	return ret;
      }
    };
    template<Player P>
    std::ostream& operator<<(std::ostream& os,Liberty8<P> const& liberty);
  } // namespace effect
} // namespace osl

template<osl::Player P>
template<typename State>
osl::effect::
Liberty8<P>::Liberty8(State const& state, Position target)
{
  BOOST_STATIC_ASSERT(! boost::is_pointer<State>::value);
  /**
   * targetˤɬ P ¦ζ𤬤٤
   */
  assert(state.getPieceAt(target).template isOnBoardByOwner<P>());
  /**
   * 10˵ζ̵ͭϿ
   * 8˵ɤΤ
   */
  NearMask nearMask=NearMask::make<State,P>(state,target);
  /**
   * 8ӥåȤΤߤɤ
   * TODO: η NearMask Ȥ̤Ǥ٤?
   */
  mask = NearMask::makeDirect(nearMask.uintValue() & 0xff);
  addMask(state,target,nearMask,ptl::PtypeListIsBasic());
}

#endif /* _LIBERTY8_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
