#ifndef _NUM_SIMPLE_EFFECT_TCC
#define _NUM_SIMPLE_EFFECT_TCC

#include "osl/effect/numSimpleEffect.h"
#include "osl/apply_move/doUndoMoveLock.h"
#include "osl/pieceTable.h"
#include "osl/record/csa.h"
#include <iostream>

/**
 * pos˶/Ĺ֥å/Ĺݤǡι.
 * xorʤΤpos˸𤬤äơˤƤӽФ롥
 * @param state - ̤ξ pos˶֤ǤǤ褤
 * @param pos - Ѳ
 */
template<class State>
template<osl::effect::NumBitmapEffect::Op OP>
void osl::effect::
NumSimpleEffectTable<State>::doBlockAt(const State& state,Position pos)
{
  mask_t mask1 =((effects[pos.index()].getMask(1))
		 & NumSimpleEffectUtil::longEffectMask());
  while (mask1.any()){
    int num=mask1.takeOneBit()+NumSimpleEffectUtil::longToNumOffset;
    assert(32<=num && num<=39);
    Piece p1=state.getPieceOf(num);
    //	Player pl1=p1.owner();
    assert(p1.ptype()!=PPAWN);
    Position pos1=p1.position();
    Offset offset0=Board_Table.getShortOffset(Offset32(pos,pos1));
    assert(! offset0.zero());
    NumBitmapEffect effect=NumSimpleEffectUtil::makeLongEffect(p1.owner(),num);
    Position pos2=pos+offset0;
    effects[pos2.index()].template opEqual<OP>(effect);
    for(;;){
      if (! state.getPieceAt(pos2).isEmpty()) break;
      pos2+=offset0;
      effects[pos2.index()].template opEqual<OP>(effect);
    }
  }
}
template<class State>
template<osl::effect::NumBitmapEffect::Op OP>
void  osl::effect::
NumSimpleEffectTable<State>::doEffect(const State& state,PtypeO ptypeo,Position pos,int num)
{
  switch(ptypeo){
  case NEW_PTYPEO(WHITE,PAWN): doEffectBy<WHITE,PAWN,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,LANCE): doEffectBy<WHITE,LANCE,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,KNIGHT): doEffectBy<WHITE,KNIGHT,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,SILVER): doEffectBy<WHITE,SILVER,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,PPAWN):
  case NEW_PTYPEO(WHITE,PLANCE):
  case NEW_PTYPEO(WHITE,PKNIGHT):
  case NEW_PTYPEO(WHITE,PSILVER):
  case NEW_PTYPEO(WHITE,GOLD): doEffectBy<WHITE,GOLD,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,BISHOP): doEffectBy<WHITE,BISHOP,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,PBISHOP): doEffectBy<WHITE,PBISHOP,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,ROOK): doEffectBy<WHITE,ROOK,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,PROOK): doEffectBy<WHITE,PROOK,OP>(state,pos,num); break;
  case NEW_PTYPEO(WHITE,KING): doEffectBy<WHITE,KING,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,PAWN): doEffectBy<BLACK,PAWN,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,LANCE): doEffectBy<BLACK,LANCE,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,KNIGHT): doEffectBy<BLACK,KNIGHT,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,SILVER): doEffectBy<BLACK,SILVER,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,PPAWN):
  case NEW_PTYPEO(BLACK,PLANCE):
  case NEW_PTYPEO(BLACK,PKNIGHT):
  case NEW_PTYPEO(BLACK,PSILVER):
  case NEW_PTYPEO(BLACK,GOLD): doEffectBy<BLACK,GOLD,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,BISHOP): doEffectBy<BLACK,BISHOP,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,PBISHOP): doEffectBy<BLACK,PBISHOP,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,ROOK): doEffectBy<BLACK,ROOK,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,PROOK): doEffectBy<BLACK,PROOK,OP>(state,pos,num); break;
  case NEW_PTYPEO(BLACK,KING): doEffectBy<BLACK,KING,OP>(state,pos,num); break;
  default: assert(0);
  }
  return;
}

template<class State>
template<osl::Player P, osl::Ptype T, osl::effect::NumBitmapEffect::Op OP>
void  osl::effect::
NumSimpleEffectTable<State>::doEffectBy(const State& state,Position pos,int num)
{
  doEffectShort<P,T,UL,OP>(pos,num);
  doEffectShort<P,T,U,OP>(pos,num);
  doEffectShort<P,T,UR,OP>(pos,num);
  doEffectShort<P,T,L,OP>(pos,num);
  doEffectShort<P,T,R,OP>(pos,num);
  doEffectShort<P,T,DL,OP>(pos,num);
  doEffectShort<P,T,D,OP>(pos,num);
  doEffectShort<P,T,DR,OP>(pos,num);
  doEffectShort<P,T,UUL,OP>(pos,num);
  doEffectShort<P,T,UUR,OP>(pos,num);
  doEffectLong<P,T,LONG_UL,OP>(state,pos,num);
  doEffectLong<P,T,LONG_U,OP>(state,pos,num);
  doEffectLong<P,T,LONG_UR,OP>(state,pos,num);
  doEffectLong<P,T,LONG_L,OP>(state,pos,num);
  doEffectLong<P,T,LONG_R,OP>(state,pos,num);
  doEffectLong<P,T,LONG_DL,OP>(state,pos,num);
  doEffectLong<P,T,LONG_D,OP>(state,pos,num);
  doEffectLong<P,T,LONG_DR,OP>(state,pos,num);
}

template<class State>
void osl::effect::
NumSimpleEffectTable<State>::init(const State& state)
{
  std::fill(effects.begin(), effects.end(),NumBitmapEffect());
  for(int num=0;num<40;num++){
    if (state.isOnBoard(num)){
      Piece p=state.getPieceOf(num);
      doEffect<NumBitmapEffect::Add>(state,p);
    }
  }
}
template<class State>
bool osl::effect::operator==(const NumSimpleEffectTable<State>& et1,const NumSimpleEffectTable<State>& et2)
{
  for(int y=1;y<=9;y++)
    for(int x=9;x>0;x--){
      Position pos(x,y);
      if (!(et1.getEffect(pos)==et2.getEffect(pos))) return false;
    }
  return true;
}

template<class State>
std::ostream& osl::effect::operator<<(std::ostream& os,const NumSimpleEffectTable<State> & effectTable)
{
  os << "EffectPass" << std::endl;
  for(int y=1;y<=9;y++){
    for(int x=9;x>0;x--){
      Position pos(x,y);
      os << static_cast<unsigned int>(effectTable.getEffectPass(pos)) << " ";
    }
    os << std::endl;
  }
  os << "Effect" << std::endl;
  for(int y=1;y<=9;y++){
    for(int x=9;x>0;x--){
      Position pos(x,y);
      os << effectTable.getEffect(pos) << " ";
    }
    os << std::endl;
  }
  return os;
}

template<class State>
bool osl::effect::operator==(const NumSimpleEffect<State>& st1,
			     const NumSimpleEffect<State>& st2)
{
  assert(st1.isConsistent(false));
  assert(st2.isConsistent(false));
  if (!(st1.effects == st2.effects)) 
    return false;
  if (!(st1.onBoardMask == st2.onBoardMask)) 
    return false;
  return (static_cast<const State&>(st1)
	  == static_cast<const State&>(st2));
}

template<class State>
osl::effect::
NumSimpleEffect<State>::NumSimpleEffect(const SimpleState& st) 
  : State(st),effects(st)
{
  onBoardMask[0].resetAll();
  onBoardMask[1].resetAll();
  for(int num=0;num<40;num++){
    Piece p=State::getPieceOf(num);
    if (p.isOnBoard()){
      getOnBoardMask(p.owner()).set(num);
    }
  }
}

template<class State>
void osl::effect::NumSimpleEffect<State>::
doSimpleMove(Position from, Position to, int promoteMask)
{
  Piece oldPiece;
  int num;
  PtypeO oldPtypeO, newPtypeO;
  if (State::getTurn()==BLACK){
    apply_move::ApplyDoUndoSimpleMove<BLACK,NumSimpleEffect<State> >
      ::prologue(*this, from, to, promoteMask, 
		 oldPiece, num, oldPtypeO, newPtypeO);
  }
  else{
    apply_move::ApplyDoUndoSimpleMove<WHITE,NumSimpleEffect<State> >
      ::prologue(*this, from, to, promoteMask, 
		 oldPiece, num, oldPtypeO, newPtypeO);
  }
  if (promoteMask!=0 && num < PtypeTraits<PAWN>::indexLimit)
    clearPawn(State::getTurn(),from);
}
template<class State>
void osl::effect::NumSimpleEffect<State>::
doCaptureMove(Position from, Position to, Piece target, int promoteMask)
{
  Piece oldPiece;
  PtypeO oldPtypeO, capturePtypeO, newPtypeO;
  int num0, num1, num1Index;
  mask_t num1Mask;
  if(State::getTurn()==BLACK){
    apply_move::ApplyDoUndoCaptureMove<BLACK,NumSimpleEffect<State> >
      ::prologue(*this, from, to, target, promoteMask, oldPiece, oldPtypeO, 
		 capturePtypeO, newPtypeO, num0, num1, num1Index,num1Mask);
  }
  else{
    apply_move::ApplyDoUndoCaptureMove<WHITE,NumSimpleEffect<State> >
      ::prologue(*this, from, to, target, promoteMask, oldPiece, oldPtypeO, 
		 capturePtypeO, newPtypeO, num0, num1, num1Index,num1Mask);
  }
  const Ptype capturePtype=target.ptype();
  if (capturePtype==PAWN)
    clearPawn(alt(State::getTurn()),to);
  if (promoteMask!=0 && num0<PtypeTraits<PAWN>::indexLimit)
    clearPawn(State::getTurn(),from);
}
template <class State>
void osl::effect::NumSimpleEffect<State>::
doDropMove(Position to,Ptype ptype)
{
  Piece oldPiece;
  PtypeO ptypeO;
  int num, numIndex;
  mask_t numMask;
  if(State::getTurn()==BLACK){
    apply_move::ApplyDoUndoDropMove<BLACK,NumSimpleEffect<State> >
      ::prologue(*this, to, ptype, oldPiece, num, ptypeO, numIndex, numMask);
  }
  else{
    apply_move::ApplyDoUndoDropMove<WHITE,NumSimpleEffect<State> >
      ::prologue(*this, to, ptype, oldPiece, num, ptypeO, numIndex, numMask);
  }
  if (ptype==PAWN)
    setPawn(State::getTurn(),to);
}
template<class State>
bool osl::effect::NumSimpleEffect<State>::isConsistent(bool showError) const
{
  if (!State::isConsistent(showError)) 
  {
    if (showError)
      std::cerr << "error before effect\n";
    return false;
  }
  NumSimpleEffectTable<typename State::simple_state_t> effects1(*this);
  if (!(effects1==effects))
  {
    if (showError)
    {
      std::cerr << "Effect error 1" << std::endl;
      std::cerr << *this;
      for(int y=1;y<=9;y++)
	for(int x=9;x>0;x--)
	{
	  Position pos(x,y);
	  if (!(effects1.getEffect(pos)==effects.getEffect(pos)))
	  {
	    std::cerr << pos << ",real=" << effects.getEffect(pos) << ",ideal=" << effects1.getEffect(pos) << std::endl;
	  }
	}
    }
    return false;
  }
  return true;
}

template<class State>
bool osl::effect::NumSimpleEffect<State>::isValidMoveByRule(Move move,bool showError) const
{
  return State::isValidMoveByRule(move,showError);
}
template<class State>
template <bool show_error>
bool osl::effect::NumSimpleEffect<State>::isAlmostValidMove(Move move) const{
  assert(move.isValid());
  assert(getTurn() == move.player());
  assert(isValidMoveByRule(move, true));

  const Position from=move.from();
  const Position to=move.to();
  const Piece toPiece=getPieceAt(to);
  const Ptype ptype=move.ptype();
  const Player turn = move.player();
    
  if (from.isPieceStand()){ // Ǥļ
    // åȤ
    if (! toPiece.isEmpty()) {
      if (show_error) std::cerr << "drop on to piece : " << move << std::endl;
      return false;
    }
    // ⤽⤽ζäƤ뤫?
    if (! hasPieceOnStand(turn,ptype)) {
      if (show_error) std::cerr << turn << " don't have : " << ptype << std::endl;
      return false;
    }
    // Υå
    if (ptype==PAWN && State::isPawnMaskSet(turn, to.x())) {
      if (show_error) std::cerr << " Double Pawn : " << move << std::endl;
      return false;
    }
  }
  else{
    const Piece from_piece = getPieceAt(from);
    // fromˤΤζ
    if (from_piece.isEmpty() || (from_piece.owner() != turn)){
      if (show_error) 
	std::cerr << " No such piece0 : " << move << std::endl;
      return false;
    }
    // promoteƤpromoteǽ
    if (move.isPromote()){
      // fromˤΤζ
      if (from_piece.ptype() != unpromote(move.ptype()))
	{
	  if (show_error) 
	    std::cerr << " No such piece1  : " << move << std::endl;
	  return false;
	}
      if (from_piece.isPromotedNotKingGold()){
	if (show_error) 
	  std::cerr << " can't promote promoted piece : " << move << std::endl;
	return false;
      }
    }
    else{
      // fromˤΤζ
      if (from_piece.ptype() != move.ptype()){
	if (show_error) 
	  std::cerr << " No such piece2  : " << move << std::endl;
	return false;
      }
    }
    // toˤΤζ𤫶?
    if (!toPiece.isEmpty() && toPiece.owner()==turn) {
      if (show_error) std::cerr << " No move on  : " << move << std::endl;
      return false;
    }
    if(!hasEffectByPiece(from_piece,to)){
      if (show_error) {
	std::cerr << " No such move2 : " << move << std::endl;
      }
      return false;
    }
    // capturePtypeפƤ뤫?
    if (toPiece.ptype()!=move.capturePtype()) {
      if (show_error) std::cerr << " Not such capture : " << move << std::endl;
      return false;
    }
  }

  assert(isValidMoveByRule(move, true));
  return true;
}

template<class State>
bool osl::effect::NumSimpleEffect<State>::
isAlmostValidMove(Move move,bool show_error) const{
  if(show_error)
    return isAlmostValidMove<true>(move);
  else
    return isAlmostValidMove<false>(move);
}

template<class State>
std::ostream& 
osl::effect::operator<<(std::ostream& os,const NumSimpleEffect<State>& state)
{
  os<< static_cast<State const&>(state);
  for(int y=1;y<=9;y++){
    os << 'P' << y;  
    for(int x=9;x>0;x--){
      Position pos(x,y);
      os << record::csa::show(state.getPieceAt(pos)) << state.getEffect(pos);
    }
    os << std::endl;
  }
  // ɽ
  for(int num=0;num<Piece::SIZE;num++){
    if (state.standMask(BLACK).test(num)){
      os << "P+00" << record::csa::show(Piece_Table.getPtypeOf(num))
	 << std::endl;
    }
    else if (state.standMask(WHITE).test(num)){
      os << "P-00" << record::csa::show(Piece_Table.getPtypeOf(num))
	 << std::endl;
    }
  }
  return os;
}

template <class BaseState>
class osl::apply_move::DoUndoMoveLockSimple<osl::effect::NumSimpleEffect<BaseState> >
  : public apply_move::DoUndoMoveLockCleanUp
{
  typedef NumSimpleEffect<BaseState> state_t;
  state_t& state;
  Position from, to;
  Piece oldPiece;
  PtypeO oldPtypeO, newPtypeO;
  int num;
  bool pawnPromotion;
public:
  DoUndoMoveLockSimple(state_t& s, 
		       Position f, Position t, int promoteMask)
    : state(s), from(f), to(t)
  {
    if(state.getTurn()==BLACK){
      apply_move::ApplyDoUndoSimpleMove<BLACK,NumSimpleEffect<BaseState> >::
	prologue(s, from, to, promoteMask, oldPiece, num, oldPtypeO, newPtypeO);
    }
    else{
      apply_move::ApplyDoUndoSimpleMove<WHITE,NumSimpleEffect<BaseState> >::
	prologue(s, from, to, promoteMask, oldPiece, num, oldPtypeO, newPtypeO);
    }
    pawnPromotion = (promoteMask!=0) && (num < PtypeTraits<PAWN>::indexLimit);
    if (pawnPromotion)
      s.clearPawn(s.getTurn(),from);
  }
  ~DoUndoMoveLockSimple()
  {
    if (pawnPromotion)
      state.setPawn(state.getTurn(),from);
    if(state.getTurn()==BLACK){
      apply_move::ApplyDoUndoSimpleMove<BLACK,NumSimpleEffect<BaseState> >::
	epilogue(state, from, to, oldPiece, num, oldPtypeO, newPtypeO);
    }
    else{
      apply_move::ApplyDoUndoSimpleMove<WHITE,NumSimpleEffect<BaseState> >::
	epilogue(state, from, to, oldPiece, num, oldPtypeO, newPtypeO);
    }
  }

};

template <class BaseState>
class osl::apply_move::DoUndoMoveLockDrop<osl::effect::NumSimpleEffect<BaseState> >
  : public apply_move::DoUndoMoveLockCleanUp
{
  typedef NumSimpleEffect<BaseState> state_t;
  state_t& state;
  Position to;
  Piece oldPiece;
  PtypeO ptypeO;
  int num, numIndex;
  mask_t numMask;
  bool pawnDrop;
public:
  DoUndoMoveLockDrop(state_t& s, Position t, Ptype ptype)
    : state(s), to(t)
  {
    if(state.getTurn()==BLACK){
      apply_move::ApplyDoUndoDropMove<BLACK,NumSimpleEffect<BaseState> >::
	prologue(s, to, ptype, oldPiece, num, ptypeO, numIndex, numMask);
    }
    else{
      apply_move::ApplyDoUndoDropMove<WHITE,NumSimpleEffect<BaseState> >::
	prologue(s, to, ptype, oldPiece, num, ptypeO, numIndex, numMask);
    }
    pawnDrop = (ptype==PAWN);
    if (pawnDrop)
      s.setPawn(s.getTurn(),to);
  }
  ~DoUndoMoveLockDrop()
  {
    if (pawnDrop)
      state.clearPawn(state.getTurn(),to);
    if(state.getTurn()==BLACK){
      apply_move::ApplyDoUndoDropMove<BLACK,NumSimpleEffect<BaseState> >::
	epilogue(state, to, oldPiece, num, ptypeO, numIndex, numMask);
    }
    else{
      apply_move::ApplyDoUndoDropMove<WHITE,NumSimpleEffect<BaseState> >::
	epilogue(state, to, oldPiece, num, ptypeO, numIndex, numMask);
    }
  }
};

template <class BaseState>
class osl::apply_move::DoUndoMoveLockCapture<osl::effect::NumSimpleEffect<BaseState> >
  : public apply_move::DoUndoMoveLockCleanUp
{
  typedef NumSimpleEffect<BaseState> state_t;
  state_t& state;
  Position from, to;
  Piece target;
  Piece oldPiece;
  PtypeO oldPtypeO, capturePtypeO, newPtypeO;
  int num0, num1;
  int num1Index;
  mask_t num1Mask;
  Ptype capturePtype;
  bool pawnPromotion, pawnCapture;
public:
  DoUndoMoveLockCapture(state_t& s, Position f, Position t, Piece tg,
			int promoteMask)
    : state(s), from(f), to(t), target(tg)
  {
    if(state.getTurn()==BLACK){
      apply_move::ApplyDoUndoCaptureMove<BLACK,NumSimpleEffect<BaseState> >::
	prologue(s, from, to, target, promoteMask, oldPiece, oldPtypeO, 
		 capturePtypeO, newPtypeO, num0, num1, num1Index,num1Mask);
    }
    else{
      apply_move::ApplyDoUndoCaptureMove<WHITE,NumSimpleEffect<BaseState> >::
	prologue(s, from, to, target, promoteMask, oldPiece, oldPtypeO, 
		 capturePtypeO, newPtypeO, num0, num1, num1Index,num1Mask);
    }
    capturePtype=target.ptype();
    pawnCapture = (capturePtype==PAWN);
    if (pawnCapture)
      s.clearPawn(alt(s.getTurn()),to);
    pawnPromotion = (promoteMask!=0) && (num0<PtypeTraits<PAWN>::indexLimit);
    if (pawnPromotion)
      s.clearPawn(s.getTurn(),from);
  }
  ~DoUndoMoveLockCapture()
  {
    if (pawnPromotion)
      state.setPawn(state.getTurn(),from);
    if (pawnCapture)
      state.setPawn(alt(state.getTurn()),to);
    if(state.getTurn()==BLACK){
      apply_move::ApplyDoUndoCaptureMove<BLACK,NumSimpleEffect<BaseState> >::
	epilogue(state, from, to, target, oldPiece, 
		 oldPtypeO, capturePtypeO, newPtypeO, 
		 num0, num1, num1Index,num1Mask);
    }
    else{
      apply_move::ApplyDoUndoCaptureMove<WHITE,NumSimpleEffect<BaseState> >::
	epilogue(state, from, to, target, oldPiece, 
		 oldPtypeO, capturePtypeO, newPtypeO, 
		 num0, num1, num1Index,num1Mask);
    }
  }
};

#endif /* _NUM_SIMPLE_EFFECT_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
