/* effectContent.h
 */
#ifndef _EFFECTCONTENT_H
#define _EFFECTCONTENT_H

#include "osl/offset.h"

namespace osl
{
  class EffectContent
  {
    int effect;
    EffectContent(int value) : effect(value)
    {
    }
  public:
    EffectContent() : effect(0)
    {
    }
    explicit EffectContent(Offset offset)
      : effect(offset.intValue() << 1)
    {
    }
    static const EffectContent DIRECT() { return EffectContent(1); }
    /**
     * ٤offsetͿ
     */
    static const EffectContent DIRECT(Offset offset) { 
      return EffectContent((offset.intValue() << 1)|1); 
    }
    /**
     * û뤫֤emptyʤĹ
     */
    bool hasEffect() const { return effect; }
    /**
     * û롥Ĺ٤ޤ
     */
    bool hasUnblockableEffect() const { return (effect & 1); }
    /**
     * ֤ͤ0ʤĹʤ, 
     * 0ʳʤéΤɬפoffset
     * (2005/3/25 ˻ѹ - Ĺ٤ξoffset֤)
     */
    const Offset offset() const { return Offset::makeDirect(effect >> 1); }
    /**
     * 2005/3/25ѹ.
     */
    bool hasBlockableEffect() const { 
      return (effect & (-effect) & ~1) != 0;
    }
    int intValue() const { return effect; }
  };

  inline bool operator==(EffectContent l, EffectContent r)
  {
    return l.intValue() == r.intValue();
  }
  inline bool operator!=(EffectContent l, EffectContent r)
  {
    return ! (l == r);
  }
  inline bool operator<(EffectContent l, EffectContent r)
  {
    return l.intValue() < r.intValue();
  }
  
} // namespace osl

#endif /* _EFFECTCONTENT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
