/* eachPlayerPieceEval.h
 */
#ifndef EVAL_EACHPLAYERPIECEEVAL_H
#define EVAL_EACHPLAYERPIECEEVAL_H

#include "osl/eval/pieceEval.h"
#include <cassert>

namespace osl
{
  namespace container
  {
    class PieceValues;
  } // namespace container
  namespace eval
  {
    /**
     * βͥ١ɾؿ.
     * ʹ٤ʬΥƻȤζβ̡ͤ˴롥
     * פPieceEval Ʊˤʤ롥
     */
    class EachPlayerPieceEval
    {
      CArray<int,2> values;
    public:
      explicit EachPlayerPieceEval(const SimpleState& state);
      static bool initialized() { return true; }
      static void setValues(const SimpleState&, container::PieceValues&);

      int value() const
      { 
	return values[0]+values[1];
      }
      int value(Player p) const
      { 
	return values[playerToIndex(p)];
      }
      static int infty() { return PieceEval::infty(); }
    private:
      void addVal(Player owner, int d) { values[playerToIndex(owner)]+=d; }
    public:
      // Ϥʤ
      // promoteѲ
      void doSimpleMove(const SimpleState& state,Position from, Position /*to*/, 
			int promote_mask)
      {
	const Piece p0=state.getPieceOnBoard(from);
	const Piece new_piece=p0.promoteWithMask(promote_mask);
	addVal(p0.owner(), 
	       Ptype_Eval_Table.value(new_piece.ptypeO())
	       - Ptype_Eval_Table.value(p0.ptypeO()));
      }
      void doDropMove(const SimpleState&, Position, Ptype)
      {
      }
      void doCaptureMove(const SimpleState& state,Position from, Position /*to*/, 
			 Piece target, int promote_mask)
      {
	const Piece p0=state.getPieceOnBoard(from);
	const Piece new_piece=p0.promoteWithMask(promote_mask);
	const PtypeO capturePtypeO=target.ptypeO();
	addVal(p0.owner(),
	       Ptype_Eval_Table.value(new_piece.ptypeO())-
	       Ptype_Eval_Table.value(p0.ptypeO())+
	       Ptype_Eval_Table.value(captured(capturePtypeO)));
	addVal(getOwner(capturePtypeO),
	       -Ptype_Eval_Table.value(capturePtypeO));
      }
      /**
       * QuiescenceSearch λ޴ǻ
       */
      static int captureValue(PtypeO ptypeO)
      {
	return Ptype_Eval_Table.captureValue(ptypeO);
      }
    };

  } // namespace eval
  using eval::EachPlayerPieceEval;
} // namespace osl

#endif /* _PIECEEVAL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
