#ifndef _EVAL_STATE_H
#define _EVAL_STATE_H
#include "osl/piece.h"
#include "osl/move.h"
#include "osl/eval/evalTraits.h"
#include "osl/apply_move/applyDoUndoXMove.h"
#include "osl/apply_move/doUndoMoveLockForward.h"

namespace osl
{
  namespace state
  {
    class SimpleState;
  }
  namespace eval
  {
    /**
     * (sample) õǤϻȤƤʤ
     * @param EvalT can be PieceEval
     */
    template<typename State,typename EvalT>
    class EvalState : public State
    {
    public:
      typedef EvalT eval_t;
    private:
      EvalT ev;

      friend class apply_move::ApplyDoUndoSimpleMove<BLACK,EvalState>;
      friend class apply_move::ApplyDoUndoCaptureMove<BLACK,EvalState>;
      friend class apply_move::ApplyDoUndoDropMove<BLACK,EvalState>;
      friend class apply_move::ApplyDoUndoSimpleMove<WHITE,EvalState>;
      friend class apply_move::ApplyDoUndoCaptureMove<WHITE,EvalState>;
      friend class apply_move::ApplyDoUndoDropMove<WHITE,EvalState>;
      friend class apply_move::DoUndoMoveLockSimple<EvalState>;
      friend class apply_move::DoUndoMoveLockCapture<EvalState>;
      friend class apply_move::DoUndoMoveLockDrop<EvalState>;
    public:
      explicit EvalState(const SimpleState& state);
      virtual ~EvalState();
      /** դΥ᥽åɤƤѤ ApplyDoUndo{Simple,Drop,Capture}Move Ƥѹ뤳 */
      void doSimpleMove(Position from, Position to, int promoteMask)
      {
	ev.doSimpleMove(*this,from,to,promoteMask);
	State::doSimpleMove(from,to,promoteMask);
      }
      void doDropMove(Position to,Ptype ptype)
      {
	ev.doDropMove(*this,to,ptype);
	State::doDropMove(to,ptype);
      }
      void doCaptureMove(Position from, Position to, Piece target, int promoteMask)
      {
	ev.doCaptureMove(*this,from,to,target,promoteMask);
	State::doCaptureMove(from,to,target,promoteMask);
      }
      bool isConsistent(bool showError=true) const;
      int getVal() const { return ev.value(); }
      const EvalT& getEval() const { return ev; }
    };

  } // namespace eval

  namespace apply_move
  {
    using eval::EvalState;
    /**
     * default Ǥ٤ ɾؿκƷ׻򥵥ܤäƤ 
     * EvalT ˥ԡ˸ʤΤȤʤä memento ѥʤɤȤΤ
     */
    template <Player P,typename Base, typename EvalT>
    struct ApplyDoUndoSimpleMove<P,EvalState<Base,EvalT> >
    {
      typedef EvalState<Base,EvalT> state_t;
      template <typename F>
      static void doUndoSimpleMove(state_t& s,
				   Position from, Position to, int promoteMask,F& func)
      {
	EvalT oldEval = s.ev;
	s.ev.doSimpleMove(s,from, to, promoteMask);
	ApplyDoUndoSimpleMove<P,Base>::template doUndoSimpleMove<F>
	  (s,from,to,promoteMask,func);
	s.ev = oldEval;
      }
    };
    template <Player P,class Base, class EvalT>
    struct ApplyDoUndoDropMove<P,EvalState<Base,EvalT> >
    {
      typedef EvalState<Base,EvalT> state_t;
      template <typename F>
      static void doUndoDropMove(state_t& s,
				 Position to, Ptype ptype,F& func)
      {
	EvalT oldEval = s.ev;
	s.ev.doDropMove(s,to,ptype);
	ApplyDoUndoDropMove<P,Base>::template doUndoDropMove<F>
	  (s,to,ptype,func);
	s.ev = oldEval;
      }
    };
    template <Player P,class Base, class EvalT>
    struct ApplyDoUndoCaptureMove<P,EvalState<Base,EvalT> >
    {
      typedef EvalState<Base,EvalT> state_t;
      template <typename F>
      static void doUndoCaptureMove(state_t& s, 
				    Position from, Position to, Piece target, int promoteMask, F& func)
      {
	EvalT oldEval = s.ev;
	s.ev.doCaptureMove(s, from, to, target, promoteMask);
	ApplyDoUndoCaptureMove<P,Base>::template doUndoCaptureMove<F>
	  (s, from, to, target, promoteMask, func);
	s.ev = oldEval;
      }
    };

    template<typename State,typename EvalT>
    class DoUndoMoveLockSimple<EvalState<State, EvalT> >;
    template<typename State,typename EvalT>
    class DoUndoMoveLockCapture<EvalState<State, EvalT> >;
    template<typename State,typename EvalT>
    class DoUndoMoveLockDrop<EvalState<State, EvalT> >;
  } // namespace apply_move
} // namespace osl
#endif /* _EVAL_STATE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
