/* alphaBetaPlayer.h
 */
#ifndef GAMEPLAYING_ALPHABETAPLAYER_H
#define GAMEPLAYING_ALPHABETAPLAYER_H

#include "osl/game_playing/searchPlayer.h"
#include <boost/scoped_ptr.hpp>

namespace osl
{
  namespace game_playing
  {
    /**
     * PieceEval Ȥץ쥤()
     */
    class PlainAlphaBetaPlayer : public SearchPlayer
    {
    public:
      PlainAlphaBetaPlayer();
      ~PlainAlphaBetaPlayer();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, int seconds);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };

    /**
     * ProgressEval Ȥ
     */
    class ProgressAlphaBetaPlayer : public SearchPlayer
    {
    public:
      ProgressAlphaBetaPlayer();
      ~ProgressAlphaBetaPlayer();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, int seconds);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };

#ifdef USE_EACH_PLAYER_PROGRESS_PLAYER
    /**
     * EachPlayerAttackDefense Ȥ
     */
    class EachPlayerProgressAlphaBetaPlayer : public SearchPlayer
    {
    public:
      EachPlayerProgressAlphaBetaPlayer();
      ~EachPlayerProgressAlphaBetaPlayer();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, int seconds);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };
#endif /* USE_EACH_PLAYER_PROGRESS_PLAYER */
  } // namespace game_playing
} // namespace osl

#endif /* GAMEPLAYING_ALPHABETAPLAYER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
