/* notKingOpenFilter.h
 */
#ifndef _MOVE_ACTION_NOT_KING_OPEN_FILTER_H
#define _MOVE_ACTION_NOT_KING_OPEN_FILTER_H
#include "osl/position.h"
#include "osl/player.h"
#include "osl/ptype.h"
#include "osl/move_action/concept.h"
#include "osl/move_classifier/kingOpenMove.h"

namespace osl
{
  namespace move_action
  {
    
    /**
     * δߤƤưʤ
     */
    template<Player P,class State,class OrigAction>
    struct NotKingOpenFilter
    {
      BOOST_CLASS_REQUIRE(OrigAction,osl::move_action,Concept);
      const State& state;
      OrigAction & action;
    public:
      NotKingOpenFilter(const State& s, OrigAction & action) 
	: state(s), action(action) {
      }
      bool isNotKingOpenMove(Ptype ptype,Position from,Position to)
      {
	return !move_classifier::KingOpenMove<P>::isMember(state, ptype, from, to);
      }
      void simpleMove(Position from,Position to,Ptype ptype, bool isPromote,Player p){
	assert(p == P);
	if(isNotKingOpenMove(ptype,from,to))
	  action.simpleMove(from,to,ptype,isPromote,P);
      
      }
      void unknownMove(Position from,Position to,Piece p1,Ptype ptype,bool isPromote,Player p){
	assert(p == P);
	if(isNotKingOpenMove(ptype,from,to))
	  action.unknownMove(from,to,p1,ptype,isPromote,P);
      }
      /**
       * dropMoveˤʤ뤳ȤϤʤ
       */
      void dropMove(Position to,Ptype ptype,Player p){
	assert(p == P);
	action.dropMove(to,ptype,P);
      }
    };
  } // namespace move_action
} // namespace osl

#endif /* _MOVE_ACTION_NOT_KING_OPEN_FILTER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
