/* safeMove.h
 */
#ifndef _MOVE_CLASSIFIER_SAFE_MOVE_H
#define _MOVE_CLASSIFIER_SAFE_MOVE_H
#include "osl/position.h"
#include "osl/player.h"
#include "osl/ptype.h"
#include "osl/piece.h"
#include "osl/move_classifier/kingOpenMove.h"
#include "osl/move_classifier/classifierTraits.h"
namespace osl
{
  namespace move_classifier
  {
    /**
     * ֤ζ̤˲꤬äƤʤ֤ǼǤʤȤå.
     * DropMoveλˤϸƤ٤ʤ
     */
    template <Player P>
    struct SafeMove
    {
      template <class State>
      static bool isMember(const State& state, 
			   Ptype ptype,Position from,Position to)
      {
	assert(! from.isPieceStand());
	assert(state.getPieceOnBoard(from).owner() == P);
	/**
	 * ꤬äƤʤȲꤷƤΤǡʬ
	 * hasEffectByƤФʤƤɤ
	 */
	if (ptype==KING)
	  return ! state.template hasEffectBy<PlayerTraits<P>::opponent>(to);
	return ! KingOpenMove<P>::isMember(state,ptype,from,to);
      }
    };

    template <Player P> struct ClassifierTraits<SafeMove<P> >
    {
      static const bool drop_suitable = false;
      static const bool result_if_drop = true;
    };
  }
}
#endif /* _MOVE_CLASSIFIER_SAFE_MOVE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
