#ifndef _GENERATE_PIECE_MOVES_TCC
#define _GENERATE_PIECE_MOVES_TCC
#include "osl/move_generator/pieceOnBoard.h"
#include "osl/move_action/concept.h"
namespace osl
{
  namespace move_generator
  {
    template<Player P,Ptype Type,PromoteType CanP,Direction Dir>
    template<class Action>
    void bits::PieceOnBoardLong<P,Type,CanP,Dir>::
    generate(const SimpleState& state,Piece p,int num,Position pos, Action& action)
    {
      //BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      const Offset offset=DirectionPlayerTraits<Dir,P>::offset();
      assert(!offset.zero());
      Position toPos=pos+offset;
      Piece p1=state.getPieceAt(toPos);
      while(p1.isEmpty()){
	if(CanP==CanPromoteType
	   || (CanP==CheckPromoteType  && toPos.canPromote<P>())){
	  action.simpleMove(pos,toPos,PtypeFuns<Type>::promotePtype,true,P);
	  if(PtypePlayerTraits<Type,P>::canDropTo(toPos))
	    action.simpleMove(pos,toPos,Type,false,P);
	}
	else{
	  action.simpleMove(pos,toPos,Type,false,P);
	}
	toPos=toPos+offset;
	p1=state.getPieceAt(toPos);
      }
      if(p1.canMoveOn<P>()){
	if(CanP==CanPromoteType 
	   || (CanP==CheckPromoteType && toPos.canPromote<P>())){
	  action.unknownMove(pos,toPos,p1,PtypeFuns<Type>::promotePtype,true,P);
	  if (PtypePlayerTraits<Type,P>::canDropTo(toPos))
	    action.unknownMove(pos,toPos,p1,Type,false,P);
	}
	else{
	  action.unknownMove(pos,toPos,p1,Type,false,P);
	}
      }
    }


    template<Player P,Ptype T,Ptype MoveT,PromoteType CanP>
    template<class Action>
    void PieceOnBoardTypePromotion<P,T,MoveT,CanP>::
    generate(const SimpleState& state,Piece p,int num,Position pos, 
	     Action& action)
    {
      PieceOnBoardDir<P,T,MoveT,CanP,UL>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,U>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,UR>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,L>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,R>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,DL>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,D>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,DR>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,UUL>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,UUR>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,LONG_UL>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,LONG_U>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,LONG_UR>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,LONG_L>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,LONG_R>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,LONG_DL>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,LONG_D>::generate(state,p,num,pos,action);
      PieceOnBoardDir<P,T,MoveT,CanP,LONG_DR>::generate(state,p,num,pos,action);
    }

    template <Player P>
    template <class Action>
    void PieceOnBoard<P>::
    generate(const SimpleState& state,Piece p, Action& action)
    {
      if (p.ptype() == PPAWN)
      {
	PieceOnBoardType<P, PPAWN>::generate(state,p,action);
      }
      else if (p.ptype() == PLANCE)
      {
	PieceOnBoardType<P, PLANCE>::generate(state,p,action);
      }
      else if (p.ptype() == PKNIGHT)
      {
	PieceOnBoardType<P, PKNIGHT>::generate(state,p,action);
      }
      else if (p.ptype() == PSILVER)
      {
	PieceOnBoardType<P, PSILVER>::generate(state,p,action);
      }
      else if (p.ptype() ==  PBISHOP)
      {
	PieceOnBoardType<P, PBISHOP>::generate(state,p,action);
      }
      else if (p.ptype() == PROOK)
      {
	PieceOnBoardType<P, PROOK>::generate(state,p,action);
      }
      else if (p.ptype() == KING)
      {
	PieceOnBoardType<P, KING>::generate(state,p,action);
      }
      else if (p.ptype() == GOLD)
      {
	PieceOnBoardType<P, GOLD>::generate(state,p,action);
      }
      else if (p.ptype() == PAWN)
      {
	PieceOnBoardType<P, PAWN>::generate(state,p,action);
      }
      else if (p.ptype() == LANCE)
      {
	PieceOnBoardType<P, LANCE>::generate(state,p,action);
      }
      else if (p.ptype() == KNIGHT)
      {
	PieceOnBoardType<P, KNIGHT>::generate(state,p,action);
      }
      else if (p.ptype() == SILVER)
      {
	PieceOnBoardType<P, SILVER>::generate(state,p,action);
      }
      else if (p.ptype() == BISHOP)
      {
	PieceOnBoardType<P, BISHOP>::generate(state,p,action);
      }
      else if (p.ptype() == ROOK)
      {
	PieceOnBoardType<P, ROOK>::generate(state,p,action);
      }
    }


  } // namespace move_generator
} // namespace osl

#endif /* _GENERATE_PIECE_MOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:

