/* offset32.h
 */
#ifndef _OFFSET32_H
#define _OFFSET32_H

#include "osl/misc/loki.h"
#include "osl/position.h"

namespace osl 
{
  /**
   *  uniqˤʤ褦ʺɸκʬ.
   * x*32+yƱΤκ
   * äȤƤɤ
   */
  class Offset32
  {
    enum {
      MIN = -(8*32+8),
      MAX = (8*32+8),
    };
  public:
    static const unsigned int SIZE=(Offset32::MAX-Offset32::MIN+1);
  private:
    int offset32;
    explicit Offset32(int o) : offset32(o)
    {
    }
  public:
    Offset32(Position to, Position from)
      : offset32(to.indexForOffset32()-from.indexForOffset32())
    {
      assert((to.x()-from.x() >= -8) && (to.x()-from.x() <= 8) 
	     && (to.y()-from.y() >= -8) && (to.y()-from.y() <= 8));
      assert(Offset32::MIN<=offset32 && offset32<=Offset32::MAX);
    }
    Offset32(int dx,int dy) : offset32(dx*32+dy) {
      assert(-9<=dx && dx<=9 && -9<=dy && dy<=9);
    }
    unsigned int index() const
    {
      return offset32 - Offset32::MIN;
    }
    bool isValid() const;
  private:
    const Offset32 blackOffset32(Int2Type<BLACK>) const { return *this; }
    const Offset32 blackOffset32(Int2Type<WHITE>) const { return Offset32(-offset32); }
  public:
    /**
     * Player P ߤ offset ֤ΤΤѹ
     */
    template<Player P>
    const Offset32 blackOffset32() const { return blackOffset32(Int2Type<P>()); }

    const Offset32 operator-() const { return Offset32(-offset32); }
  private:
    // these functions are *intentionally* unimplemented for the moment.
    // don't forget the fact that x or y can be negative.
    int dx(Offset32 offset32);
    int dy(Offset32 offset32);
  };
} // namespace osl


#endif /* _OFFSET32_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
