/* ptpeProgress.h
 */
#ifndef PROGRESS_PTYPE_PROGRESS_H
#define PROGRESS_PTYPE_PROGRESS_H

#include "osl/ptype.h"
#include "osl/state/simpleState.h"
#include "osl/misc/carray.h"
#include <iosfwd>
namespace osl
{
  namespace progress
  {
    /** οʹ٤𤬼ؤɤ˿ʤǤ뤫¤ɽ
     */
    class PtypeProgressTable
    {
    private:
      CArray<int,PTYPE_SIZE> ptype2Val;
      CArray2d<int,PTYPEO_SIZE,Position::SIZE> pos2Val;
      static const CArray<int,10> yVals;
    public:
      PtypeProgressTable();
      ~PtypeProgressTable();
      int progress(PtypeO ptypeo,Position pos) const{
	return pos2Val[ptypeo-PTYPEO_MIN][pos.index()];
      }
    };
    extern const PtypeProgressTable Ptype_Progress_Table;

    class PtypeProgress
    {
      int val;
    public:
      explicit PtypeProgress(SimpleState const& state);
      int progress() const{ return val; }
    private:
      void addVal(int d) { val+=d; }
    public:
      static int getProgress(const SimpleState& state)
      {
	const PtypeProgress progress(state);
	return progress.progress();
      }
      void doSimpleMove(const SimpleState& state,Position from, Position to, 
			int /*promote_mask*/)
      {
	const Piece moving = state.getPieceOnBoard(from);
	const PtypeO ptypeo = moving.ptypeO(); //  promote ͤ˱ƶʤ
	val += Ptype_Progress_Table.progress(ptypeo,to)
	  - Ptype_Progress_Table.progress(ptypeo,from);
      }
      void doDropMove(const SimpleState& state,Position to,Ptype ptype)
      {
	PtypeO ptypeo = newPtypeO(state.getTurn(), ptype);
	val += Ptype_Progress_Table.progress(ptypeo,to)
	  - Ptype_Progress_Table.progress(ptypeo,Position::STAND());
      }
      void doCaptureMove(const SimpleState& state,Position from, Position to, 
			 Piece target,int /*promote_mask*/)
      {
	const Piece moving = state.getPieceOnBoard(from);
	const PtypeO ptypeo = moving.ptypeO(); //  promote ͤ˱ƶʤ
	const PtypeO capturePtypeO = target.ptypeO();

	val += Ptype_Progress_Table.progress(capturePtypeO, Position::STAND())
	  - Ptype_Progress_Table.progress(capturePtypeO, to)
	  + Ptype_Progress_Table.progress(ptypeo, to)
	  - Ptype_Progress_Table.progress(ptypeo, from);
      }

      bool operator==(const PtypeProgress rhs) const { return val == rhs.val; }
    };
    std::ostream& operator<<(std::ostream& os, PtypeProgress prog);
  } // namespace progress
  using progress::PtypeProgress;
} // namespace osl


#endif /* PROGRESS_PTYPE_PROGRESS_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
