#ifndef _KISEN_H
#define _KISEN_H

#include "osl/record/record.h"
#include "osl/position.h"
#include "osl/misc/carray.h"
#include <string>
#include <iosfwd>
#include <fstream>
namespace osl
{
  namespace record
  {
    class KisenUtils{
    public:
      static Position convertPosition( int pos );
      static Move convertMove( SimpleState const& state,int c0,int c1 );
    };

    class IKisenStream : public IRecordStream{
    private:
      CArray<unsigned char, 512> cbuf;
      SimpleState state;
      RecordVisitor rv;
    public:
      IKisenStream(char const readbuf[]) : state(HIRATE) {
	std::copy(&readbuf[0],&readbuf[512],&cbuf[0]);
      }
      SimpleState getState() const { return state;}
      virtual void load(Record*);
      virtual ~IKisenStream(){};
    };
    // .kifפȤĥҤĴե
    // ΤߤξäƤ
    class KisenFile{
    private:
      std::ifstream ifs;
      size_t numberOfGames;
      SimpleState const initialState;
    public:
      static const size_t maxMoves=256;
      explicit KisenFile(const std::string& fileName);
      size_t size() const{ return numberOfGames; }
      SimpleState const& getInitialState() const{ return initialState; }
      const vector<Move> getMoves(size_t index);
    };
    // .ipxפȤĥҤĴե
    // жɼԤ˴ؤ(֥ץ쥤䡼̾ס֥졼ƥ󥰡)
    // ʬäƤ롥
    class KisenIpxFile{
      std::ifstream ifs;
      size_t numberOfGames;
    public:
      explicit KisenIpxFile(std::string const& fileName);
      size_t size() const{ return numberOfGames; }
      const std::string getPlayer(size_t index,Player pl);
      const std::string getTitle(size_t index,Player pl);
      unsigned int getRating(size_t index,Player pl);
    };
    // .kpfפȤĥҤĴץ饹ե
    // ֤ξäƤ
    class KisenPlusFile{
    private:
      std::ifstream ifs;
      size_t numberOfGames;
      SimpleState const initialState;
    public:
      static const size_t maxMoves=256;
      explicit KisenPlusFile(const std::string& fileName);
      size_t size() const{ return numberOfGames; }
      SimpleState const& getInitialState() const{ return initialState; }
      const vector<Move> getMoves(size_t index);
      void getMoves(size_t index, vector<Move>&, vector<int>&);
    };
  } // namespace record
  using record::KisenFile;
  using record::KisenIpxFile;
} // namespace osl
#endif // _KISEN_H 
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
