/* dotAnalyzer.h
 */
#ifndef _DOTANALYZER_H
#define _DOTANALYZER_H

#include "osl/move.h"
#include "osl/search/analyzer/recordSet.h"
#include <boost/scoped_ptr.hpp>
#include <iosfwd>

namespace osl
{
  namespace hash
  {
    class HashKey;
  }
  namespace search
  {
    class SimpleHashTable;
    namespace analyzer
    {
      class LogWriter;
      /**
       * õΥơ֥ʬ.
       * dot (www.graphviz.org) .
       */
      class DotAnalyzer
      {
      protected:
	const SimpleHashTable& table;
	boost::scoped_ptr<LogWriter> writer;
	RecordSet dejavu;
      public:
	typedef hash::HashKey HashKey;

	DotAnalyzer(const SimpleHashTable&, std::ostream&);
	virtual ~DotAnalyzer();

	/**
	 * root  limit ޤǤμ򥰥ղ
	 */
	virtual void analyze(const HashKey& root, int limit) = 0;
	virtual void analyzeQuiescence(const HashKey& root) = 0;
	/**
	 * ɤ٤μդɽ
	 */
	void analyzeSequence(const HashKey& root, int limit,
			     const Move *first, const Move *last);
      protected:
	/**
	 * writer 򺹤ؤ. ͭϰž
	 */
	void resetWriter(LogWriter *);
      };
      
    } // namespace analyzer
  } // namespace search
} // namespace osl

#endif /* _DOTANALYZER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
