/* killerMoveTable.h
 */
#ifndef _KILLERMOVETABLE_H
#define _KILLERMOVETABLE_H

#include "osl/search/lRUMoves.h"
#include "osl/container/moveVector.h"
#include "osl/state/numEffectState.h"
#include <cstddef>
#include <cassert>
namespace osl
{
  namespace search
  {
    /**
     * ñkiller move
     *
     * ȤκϿ롥ơ֥ϿƤʤ̤ǡ
     * ּʬؤ꤫餳ؤȺפȸȤͭ
     * ȽϤøǡοǺǸbestMoveȤȯ줿move
     */
    class KillerMoveTable
    {
    public:
      static const int KillerMoveMax = 64;
    private:
      CArray<LRUMoves,KillerMoveMax> killer_moves;
    public:
      KillerMoveTable();
      ~KillerMoveTable();
      void clear();
      void setMove(size_t depth, const Move& move)
      {
	assert(move.isValid());
	killer_moves[depth].setMove(move);
      }
      void getMove(const NumEffectState& state, size_t depth,
		   MoveVector& out) const
      {
	const LRUMoves& moves = killer_moves[depth];
	for (size_t i=0; i<moves.size(); ++i)
	{
	  if (! moves[i].isNormal())
	    return;
	  if (state.isAlmostValidMove<false>(moves[i]))
	    out.push_back(moves[i]);
	}
      }
    };
  } // namespace search
} // namespace osl

#endif /* _KILLERMOVETABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
