/* nullWindowSearchPolicy.h
 */
#ifndef SEARCH_NULLWINDOWSEARCHPOLICY
#define SEARCH_NULLWINDOWSEARCHPOLICY

#include "osl/search/nullWindowSearch.h"
namespace osl
{
  namespace search
  {
    namespace null_window
    {
      /**
       * examineMoves ͳǼ¹Ԥ륳
       */
      template <typename NullWindowSearch, Player P,
		bool best_move_extension>
      struct NullWindowSearchPolicy
      {
	typedef NullWindow window_t;
	typedef NullWindowSearch searcher_t;
	
	NullWindowSearch *searcher;
	NullWindow my_window;
	NullWindowSearchPolicy(NullWindowSearch *s, NullWindow window) 
	  : searcher(s), my_window(window)
	{
	}
	void setSearcher(NullWindowSearch *new_searcher){
	  searcher = new_searcher;
	}
	/** @return cut Ǥ뤫 */
	bool searchWithMove(const SearchMove& ml, int& max_value, 
			    SearchMove& best_move) const
	{
	  return (*searcher).template
	    nullWindowSearch<P,best_move_extension>
	    (ml, max_value, best_move);
	}
	static const bool isBestMoveExtension = best_move_extension;
	const NullWindow window() const { return my_window; }
	template <class Recorder>
	TableHit isOutOfWindow(Player p, const SimpleHashRecord& record, 
			       int limit, int& val, const Recorder& recorder) const
	{
	  assert(P == p);
	  return NullWindowUtil<P,NullWindowSearch,best_move_extension>::
	    isOutOfWindow(record, limit, my_window, val, recorder);
	}
	void recordToTable(Player p,
			   SimpleHashRecord *record, int limit, 
			   const SearchMove& best_move, int val) const
	{
	  assert(P == p);
	  assert(record);
	  assert(limit >= 0);
	  if (EvalTraits<P>::betterThan(val, my_window.alpha()))
	  {
	    searcher->recordLowerBound(P, record, limit, best_move, val);
	  }
	  else
	  {
	    assert(EvalTraits<P>::betterThan(my_window.alpha(), val));
	    searcher->recordUpperBound(P, record, limit, best_move, val);
	  }
	}
      };

      /**
       * searchWithMove ƤФ
       * @param P move ؤ
       */
      template <typename NullWindowSearch, Player P, bool best_move_extension>
      struct DoUndoNullWindow
      {
	NullWindowSearch *searcher;
	const SearchMove& moved;
	int max_value;
	int *result;
	DoUndoNullWindow(NullWindowSearch *s, const SearchMove& md, int m)
	  : searcher(s), moved(md), max_value(m)
	{
	  assert(P == md.getMove().player());
	}
	void setResultAddress(int *result)
	{
	  this->result = result;
	}
	void operator()(Position /*last_to*/)
	{
#ifndef NDEBUG
	  const int cur_limit = searcher->curLimit();
#endif
	  *result = (*searcher).template 
	    nullWindowSearchAfterMove<P,best_move_extension>(moved, max_value);
	  assert(cur_limit == searcher->curLimit());
	}
      };
    } // namespace null_window
  } // namespace search
} // namespace osl


#endif /* SEARCH_NULLWINDOWSEARCHPOLICY */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
