/* PawnMaskState.tcc
 */
#ifndef _PAWN_MASK_STATE_TCC
#define _PAWN_MASK_STATE_TCC

#include "osl/state/pawnMaskState.h"
#include "osl/apply_move/doUndoMoveLock.h"
namespace osl
{
  template<>
  class apply_move::DoUndoMoveLockSimple<PawnMaskState> : public apply_move::DoUndoMoveLockCleanUp
  {
    PawnMaskState& state;
    Position from, to;
    Piece oldPiece;
    int num;
    bool clearPawn;
  public:
    DoUndoMoveLockSimple(PawnMaskState& s, 
			 Position f, Position t, int promoteMask);
    ~DoUndoMoveLockSimple();
  };

  template<>
  class apply_move::DoUndoMoveLockDrop<PawnMaskState> : public apply_move::DoUndoMoveLockCleanUp
  {
    PawnMaskState& state;
    Position to;
    Piece oldPiece;
    int num, numIndex, numLow;
    bool pawnDrop;
  public:
    DoUndoMoveLockDrop(PawnMaskState& state, 
		       Position to, Ptype ptype);
    ~DoUndoMoveLockDrop();
  };
  
  template<>
  class apply_move::DoUndoMoveLockCapture<PawnMaskState> : public apply_move::DoUndoMoveLockCleanUp
  {
    PawnMaskState& state;
    Position from, to;
    Piece target;
    Piece oldPiece;
    int num0, num1;
    int num1Index;
    mask_t num1Mask;
    Ptype capturePtype;
    bool pawnPromotion, pawnCapture;
  public:
    DoUndoMoveLockCapture(PawnMaskState& state, 
			  Position from, Position to, Piece target,
			  int promoteMask);
    ~DoUndoMoveLockCapture();
  };

} // namespace osl

#endif /* _PAWN_MASK_STATE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
