/* hash_map.h
 */
#ifndef HASH_MAP_H
#define HASH_MAP_H

#include "osl/stl/hash.h"
#include "osl/stl/pool_allocator.h"
#include <ext/hash_map>

namespace osl
{
  namespace stl
  {
    template <class T>
    struct hash;
  
    template<class Key, class Value, class HashFun=hash<Key>,
	     class EqualKey=std::equal_to<Key> >
    struct hash_map
      : public __gnu_cxx::hash_map<Key, Value, HashFun, EqualKey,
				   pool_allocator<Value> >
    {
      typedef __gnu_cxx::hash_map<Key, Value, HashFun, EqualKey,
				  pool_allocator<Value> > base_t;
      hash_map() {}
      hash_map(size_t s) : base_t(s)
      {
      }
    };
  } // namespace stl
  using stl::hash_map;
} // namespace stl


#endif /* HASH_MAP_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
