/* vector.h
 */
#ifndef VECTOR_H
#define VECTOR_H

#include <vector>
#include "osl/stl/pool_allocator.h"

namespace osl
{
  namespace stl
  {
    template <class T>
    struct vector : public std::vector<T,pool_allocator<T> >
    {
      typedef std::vector<T,pool_allocator<T> > base_t;
      vector() {}
      explicit vector(size_t s) : base_t(s)
      {
      }
      vector(size_t s, const T& val) : base_t(s,val)
      {
      }
    };
  } // namespace stl
  using stl::vector;
} // namespace stl

#endif /* VECTOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
