/* directionTable.cc
 */
#include "osl/boardTable.h"
#include "osl/directionTraits.h"

template <osl::Direction Dir>
void osl::BoardTable::setDirections(){
  Offset offset=Offset(DirectionTraits<Dir>::blackDx,
		       DirectionTraits<Dir>::blackDy);
  for(int i=1;i<=8;i++){
    int dx=i*DirectionTraits<Dir>::blackDx;
    int dy=i*DirectionTraits<Dir>::blackDy;
    Offset32 offset32=Offset32(dx,dy);
    directions[offset32.index()]=Dir;
    short_offsets[offset32.index()]=offset;
    short_offsets_not_knight[offset32.index()]=offset;
  }
}
template <osl::Direction Dir>
void osl::BoardTable::setKnightDirections(){
  int dx=DirectionTraits<Dir>::blackDx;
  int dy=DirectionTraits<Dir>::blackDy;
  Offset32 offset32=Offset32(dx,dy);
  Offset offset=Offset(dx,dy);
  short_offsets[offset32.index()]=offset;
  short_offsets[(-offset32).index()]= -offset;
}

void osl::BoardTable::init(){
  directions.fill();
  short_offsets_not_knight.fill();

  setDirections<LONG_UL>();
  setDirections<LONG_U>();
  setDirections<LONG_UR>();
  setDirections<LONG_L>();
  setDirections<LONG_R>();
  setDirections<LONG_DL>();
  setDirections<LONG_D>();
  setDirections<LONG_DR>();
  setKnightDirections<UUL>();
  setKnightDirections<UUR>();
}

osl::BoardTable::BoardTable(){
  init();
  assert(! getOffset(BLACK, UL).zero());
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
