/* probOfEachCategory.cc
 */
#include "osl/category/analyzer/probOfEachCategory.h"
#include "osl/category/moveEvaluation.h"
#include "osl/category/categoryUtil.h"
#include "osl/eval/pieceEval.h"
#include <iostream>

osl::category::analyzer::ProbOfEachCategory::
Reporter::Reporter(std::ostream& o, bool v) : os(o), verbose(v)
{
}

void osl::category::analyzer::ProbOfEachCategory::
Reporter::found(const char *name, int prob)
{
  os << name << " " << prob << "\n";
}
void osl::category::analyzer::ProbOfEachCategory::
Reporter::notFound(const char *name)
{
  if (verbose)
    os << name << " N/A\n";
}

/* ------------------------------------------------------------------------- */
osl::category::analyzer::ProbOfEachCategory::
ProbOfEachCategory(const CategoryEnv& e, Move t, CallBack *f)
  : env(e), target(t), function(f)
{
  Position8 sendoffs;
  CategoryUtilBase::findSendOff(e, sendoffs);
  classify_piece_value = MoveEvaluation::evalDetailed(env, t, sendoffs);
}

bool osl::category::analyzer::
ProbOfEachCategory::analyze(NullCategory)
{
  return false;
}

void osl::category::analyzer::
ProbOfEachCategory::analyzeClassify(NullCategory)
{
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
