/* ptypePtypeProbTable.cc
 */
#include "osl/category/ptypePtypeProbTable.h"
#include "osl/category/probTable.tcc"
#include <iostream>

osl::category::
PtypePtypeProbTable::PtypePtypeProbTable(const char *h, const char *n)
  : base_t(h,n)
{
}

void osl::category::
PtypePtypeProbTable::show()
{
  // ǤޤȤˤ
  for (int i=-PieceValueTable::RANGE; i<PieceValueTable::RANGE; i+=64)
  {
    const int index = getIndex(PAWN, false, ROOK, i);
    std::cerr << i << "\t" << index << "\t" << prob[index] << "\n";
    std::cerr << PieceValueTable::getIndex(i) << "\n";
  }
}

void osl::category::PtypePtypeProbTable::
interpolate()
{
  int lastVal = CategoryTraits::maxProb();
  for (size_t i=0; i<indexMax(); ++i)
  {
    if ((i % PieceValueTable::indexMax()) == 0)
      lastVal = CategoryTraits::maxProb();
    if (prob[i] == 0)
    {
      prob[i] = lastVal;	// 0 ä(갭֤)Ƥ
    }
    else
    {
      lastVal = std::min(prob[i], lastVal);
    }
  }
}

osl::category::
PtypePtype2ProbTable::PtypePtype2ProbTable(const char *h, const char *n)
  : base_t(h,n)
{
}

void osl::category::PtypePtype2ProbTable::
interpolate()
{
  int lastVal = CategoryTraits::maxProb();
  for (size_t i=0; i<indexMax(); ++i)
  {
    if ((i % PieceValueTable::indexMax()) == 0)
      lastVal = CategoryTraits::maxProb();
    if (prob[i] == 0)
    {
      // Х˼夤ʤΤǽľ?

      // 0 ä(갭֤)
      // 2ܤμ꤬ΤΤ
      // 2*16*2*16*16*PieceValueTableLength
      //      
      const size_t ignored0 = ((i / PieceValueTableLength) & (~(31*16)))
	*PieceValueTableLength + (i % PieceValueTableLength);
      if ((i != ignored0) && prob[ignored0] && (lastVal > prob[ignored0]))
      {
	lastVal = prob[ignored0];
      }
      const size_t ignored1 = ((ignored0 / PieceValueTableLength) ^ (16*16))
	* PieceValueTableLength + (i % PieceValueTableLength);
      if ((i != ignored1) && prob[ignored1] && (lastVal > prob[ignored1]))
      {
	lastVal = prob[ignored1];
      }
#if 0      
      // promote ͤ
      // 2*16*2*16*16*PieceValueTableLength
      //  
      const size_t ptype1base = 2*16*16*PieceValueTableLength;
      const Ptype ptype1 = static_cast<Ptype>((ignored0 / ptype1base) & 15);
      if (isPiece(ptype1))
      {
	const size_t unpromote0 = unpromote(ptype1) * ptype1base 
	  + (ignored0 % ptype1base);
	if ((i != unpromote0) && prob[unpromote0] && (lastVal > prob[unpromote0]))
	{
	  lastVal = prob[unpromote0];
	}
	const size_t unpromote1 = unpromote0 + 16*ptype1base;
	if ((i != unpromote1) && prob[unpromote1] && (lastVal > prob[unpromote1]))
	{
	  lastVal = prob[unpromote1];
	}
      }
#endif
      prob[i] = lastVal;
    }
    else
    {
      lastVal = prob[i];
    }
  }
}

osl::category::
PtypeValueTable::PtypeValueTable(const char *h, const char *n)
  : base_t(h,n)
{
}

void osl::category::PtypeValueTable::
interpolate()
{
  int lastVal = CategoryTraits::maxProb();
  for (size_t i=0; i<indexMax(); ++i)
  {
    if ((i % PieceValueTable::indexMax()) == 0)
      lastVal = CategoryTraits::maxProb();
    if (prob[i] == 0)
    {
      prob[i] = lastVal;	// 0 ä(갭֤)Ƥ
    }
    else
    {
      lastVal = prob[i];
    }
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
