/* checkMoveList.cc
 */
#include "osl/checkmate/checkMoveList.h"
#include "osl/checkmate/checkHashRecord.h"
#include <iostream>

std::ostream& osl::checkmate::
operator<<(std::ostream& os, const CheckMoveList& l)
{
  for (CheckMoveList::const_iterator p=l.begin(); p!=l.end(); ++p)
  {
    os << p->move << " ";
  }
  return os << "\n";
}

const osl::checkmate::CheckMove* osl::checkmate::
CheckMoveList::find(Move move) const
{
  for (const_iterator p=begin(); p!=end(); ++p)
  {
    if (p->move == move)
      return &*p;
  }
  return 0;
}

osl::checkmate::CheckMove* osl::checkmate::
CheckMoveList::find(Move move)
{
  for (iterator p=begin(); p!=end(); ++p)
  {
    if (p->move == move)
      return &*p;
  }
  return 0;
}

void osl::checkmate::
CheckMoveList::dump(std::ostream& os) const
{
  os << "moves size " << size() << "\n";
  for (const_iterator p=begin(); p!=end(); ++p)
  {
    os << "moves " << p->flags << " " << p->move;
    if (p->record)
    {
      os << " " << p->record->proofDisproof()
	 << " " << p->record << " parent " << p->record->parent;
    }
    else
    {
      os << " h " << (int)p->h_proof << " " << (int)p->h_disproof
	 << " c " << (int)p->cost_proof << " " << (int)p->cost_disproof;
    }
    os << "\n";
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
