#include "osl/container/ptypeOPositionVector.h"
#include "osl/eval/pieceEval.h"
#include <algorithm>

namespace osl
{
  struct PtypeOPositionLessThan
  {
    bool operator()(const std::pair<PtypeO,Position>& l,
		    const std::pair<PtypeO,Position>& r)
    {
      const Ptype ptypel=unpromote(getPtype(l.first));
      const Ptype ptyper=unpromote(getPtype(r.first));
      const int vall = eval::Ptype_Eval_Table.value(ptypel);
      const int valr = eval::Ptype_Eval_Table.value(ptyper);
      if (vall != valr)
	return vall < valr;
      return l.second.uintValue() < r.second.uintValue();
    }
  };

  void container::PtypeOPositionVector::sort()
  {
    std::sort(begin(),end(),PtypeOPositionLessThan());
  }

}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
