#include "osl/eval/eachPlayerPieceEval.h"
#include "osl/container/pieceValues.h"
#include "osl/pieceTable.h"

void osl::
EachPlayerPieceEval::setValues(const SimpleState& state, PieceValues& out)
{
  for (int i=0; i<Piece::SIZE; i++) {
    const Piece target = state.getPieceOf(i);
    out[i] = Ptype_Eval_Table.value(target.ptypeO());
  }
}

osl::
EachPlayerPieceEval::EachPlayerPieceEval(const SimpleState& state)
{
  int black=0, white=0;
  for (int num=0;num<Piece::SIZE;num++) {
    if (state.standMask(BLACK).test(num))
    {
      black 
	+=Ptype_Eval_Table.value(newPtypeO(BLACK,Piece_Table.getPtypeOf(num)));
    }
    else if (state.standMask(WHITE).test(num))
    {
      white 
	+=Ptype_Eval_Table.value(newPtypeO(WHITE,Piece_Table.getPtypeOf(num)));
    }
    else{
      assert(state.isOnBoard(num));
      const Piece p=state.getPieceOf(num);
      if (p.owner() == BLACK)
	black+=Ptype_Eval_Table.value(p.ptypeO());
      else
	white+=Ptype_Eval_Table.value(p.ptypeO());
    }
  }
  values[playerToIndex(BLACK)] = black;
  values[playerToIndex(WHITE)] = white;
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
