/* eachPlayerProgressEval.cc
 */
#include "osl/eval/eachPlayerProgressEval.h"
#include "osl/container/pieceValues.h"
#include "osl/state/numEffectState.h"

void osl::eval::
EachPlayerProgressEval::setValues(const SimpleState& state, 
			Progress16 black_progress16,
			Progress16 white_progress16,
			PieceValues& out)
{
  PieceValues opening, endgame;
  opening_eval_t::setValues(state, opening);
  endgame_eval_t::setValues(state, endgame);
  additional_eval_t::setValues(state, out);
  for (int i=0; i<Piece::SIZE; ++i)
  {
    const Player owner = state.getPieceOf(i).owner();
    const Progress16 progress
      = (owner == BLACK) ? black_progress16 : white_progress16;
    out[i] += composeValue(opening[i] & (~1), endgame[i] & (~1), progress);
  }
}

void osl::eval::
EachPlayerProgressEval::setValues(const SimpleState& state, PieceValues& out)
{
  const NumEffectState nstate(state);
  const progress_t progress(nstate);
  setValues(state, progress.progress16(BLACK), progress.progress16(WHITE),
	    out);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
