/* piecePairPieceTable.cc
 */
#include "osl/eval/ppair/piecePairPieceEval.h"
#include "osl/eval/ppair/piecePairRawEval.h"
#include "osl/eval/ppair/piecePairEval.tcc"
#include "osl/eval/ppair/piecePairWithStand.tcc"
#include "osl/eval/pieceEval.h"

namespace osl
{
  namespace eval
  {
    namespace ppair
    {
      template class PiecePairEvalTableBase<PiecePairPieceTable>;
      template class PiecePairEval<PiecePairWithStand<PiecePairPieceTable>,PiecePairPieceTable>;
      template class PiecePairWithStand<PiecePairPieceTable>;
    } // namespace ppair
  } // namespace eval
} // namespace osl

osl::eval::ppair::
PiecePairPieceTable::PiecePairPieceTable()
{
}

osl::eval::ppair::
PiecePairPieceTable::~PiecePairPieceTable()
{
}


bool osl::eval::ppair::
PiecePairPieceTable::
setUp(const char *filename) const
{
  if (! PiecePairRawEval::setUp(filename))
    return false;

  for (unsigned int i=0; i<maxPairIndex; ++i)
  {
    values[i] = PiecePairRawTable::Table.value(i)
      *128/100; // scale up according to pawn value change
  }

  for (int y=1; y<=9; ++y)
  {
    for (int x=1; x<=9; ++x)
    {
      const Position position(x,y);
      for (int p=PTYPEO_MIN; p<=PTYPEO_MAX; ++p)
      {
	const PtypeO ptypeo = static_cast<PtypeO>(p);
	if (! isPiece(ptypeo))
	  continue;
	const unsigned int index = indexOf(position, ptypeo);
	values[indexOf(index, index)] += Ptype_Eval_Table.value(ptypeo);
      }
    }
  }
  return true;
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
