/* progressEval.cc
 */
#include "osl/eval/progressEval.h"
#include "osl/container/pieceValues.h"
#include "osl/state/numEffectState.h"

BOOST_STATIC_ASSERT((osl::eval::ProgressEval::ROUND_UP 
		     & (osl::eval::ProgressEval::ROUND_UP-1))
		    == 0);

void osl::eval::
ProgressEval::setValues(const SimpleState& state, Progress16 progress16,
			PieceValues& out)
{
  PieceValues opening, endgame;
  const NumEffectState nstate(state);
  const progress_t progress(nstate);
  const defense_t defense_effect(nstate);
  const MinorPieceBonus minor_piece_bonus(state);
  opening_eval_t::setValues(state, opening);
  endgame_eval_t::setValues(state, endgame);
  for (int i=0; i<Piece::SIZE; ++i)
  {
    out[i] = composeValue(opening[i] & (~1), endgame[i] & (~1), progress16,
			  progress.progress16(BLACK),
			  progress.progress16(WHITE),
			  defense_effect.progress16(BLACK),
			  defense_effect.progress16(WHITE),
			  minor_piece_bonus.value(progress16));
  }
}

void osl::eval::
ProgressEval::setValues(const SimpleState& state, PieceValues& out)
{
  const NumEffectState nstate(state);
  const progress_t progress(nstate);
  setValues(state, progress.progress16(), out);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
