/* perfmon.cc
 */
#include "osl/misc/perfmon.h"
#include <iostream>
#include <iomanip>

void osl::misc::PerfMon::message(unsigned long long cycles,
				 const char *message,long long int loop)
{
#ifdef HAVE_TSC
  const char *unit = "clocks";
#else
  const char *unit = "microSecs";
#endif  
  std::cerr << std::dec << message << " : take " << cycles 
	    << " " << unit << ", loop= " << loop;
  if (loop)
    std::cerr << " clocks/loop= " <<  (cycles/loop) << "." 
	      << std::setfill('0') << std::setw(2) 
	      << (cycles*100/loop)-(cycles/loop)*100;
  std::cerr << std::endl;
}

osl::misc::MeasureTimeLock::~MeasureTimeLock ()
{
  timeval end;
  gettimeofday(&end, NULL);

  end.tv_usec -= start.tv_usec;

  if (end.tv_usec < 0)
  {
    end.tv_usec += 1000000;
    --end.tv_sec;
  }
  end.tv_sec -= start.tv_sec;

  os << message << "\t"
     << end.tv_sec << ":" << end.tv_usec
     << std::endl;
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
