#include "osl/move_generator/addEffect.h"
#include "osl/move_generator/addEffect.tcc"
#include "osl/move_action/store.h"
#include "osl/state/numEffectState.h"
#ifdef RELEASE
#include "osl/move_generator/open.tcc"
#endif

namespace osl{
  // explicit template instantiation
  namespace move_generator
  {
    typedef move_action::Store store_t;
    template void GenerateAddEffect<true>::generate
    (Player, const NumEffectState&, Position, store_t&);
    template void GenerateAddEffect<false>::generate
    (Player, const NumEffectState&, Position, store_t&);

    typedef move_action::SafeFilter<BLACK,NumEffectState,store_t> safe_black_t;
    typedef move_action::SafeFilter<WHITE,NumEffectState,store_t> safe_white_t;

    // forEachOnBoard Τ NumEffectState Ǥ̣
    template void AddEffect<BLACK,false>::generate(const NumEffectState&, Position,
						   store_t&);
    template void AddEffect<WHITE,false>::generate(const NumEffectState&, Position, 
						   store_t&);
    // for fixed depth search
    template void AddEffect<BLACK, true>::generate(const NumEffectState&, Position, store_t&);
    template void AddEffect<WHITE, true>::generate(const NumEffectState&, Position, store_t&);

#ifdef NEED_EXTRA_TEMPLATE_INSTANTIATION
    template void AddEffect<BLACK, true>::generate<NumEffectState, move_action::SafeFilter<BLACK, NumEffectState, move_action::Store> >(NumEffectState const&, Position, move_action::SafeFilter<BLACK, NumEffectState, move_action::Store>&);
    template void AddEffect<WHITE, true>::generate<NumEffectState, move_action::SafeFilter<WHITE, NumEffectState, move_action::Store> >(NumEffectState const&, Position, move_action::SafeFilter<WHITE, NumEffectState, move_action::Store>&);
#endif

  } // namespace move_generator
} // namespace osl
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
