/* effect5x3.cc
 */
#include "osl/progress/effect5x3d.h"
#include "osl/progress/effect5x3Table.h"

int osl::progress::
Effect5x3d::makeProgress(Player defense, const NumEffectState& state,
			 Position king)
{
  
  const Position center = Centering5x3::adjustCenter(king);

  const int min_x = center.x() - 2;
  const int max_x = center.x() + 2;
  const int min_y = center.y() - 1;
  const int max_y = center.y() + 1;

  // 
  int sum_effect = 0;

  for (int x=min_x; x<=max_x; ++x)
    {
      for (int y=min_y; y<=max_y; ++y)
	{
	  const Position target(x,y);
	  sum_effect += state.countEffect(defense, target);
	}
    }

  return sum_effect * 8;
}

namespace osl
{
  namespace progress
  {
    namespace
    {
      /**
       * 5x3ΰ褬뤫.
       * 8ܤ줿Τ֤
       * @param checkPass(template) - passͭˤ뤫ɤ
       * @param state - 
       * @param pos - λϤޤ
       * @param offset - бoffset
       * @param minIndex - 5x3ΰλϤޤindex
       * @param maxIndex - 5x3ΰκǸindex
       * @param pass - ΰ֤϶Ȥư
       */
      template<bool checkPass>
      inline int 
      countLongEffect(NumEffectState const& state,Position pos,
		      Offset offset, int minIndex,int maxIndex,
		      Position pass=Position::STAND())
      {
	int ret=0;
	pos+=offset;
	int j;
	for(j=1;j<minIndex;j++,pos+=offset){
	  if(!state.getPieceAt(pos).isEmpty() && (!checkPass || pos!=pass))
	    return 0;
	}
	for(;j<=maxIndex;j++,pos+=offset){
	  ret+=8;
	  if(!state.getPieceAt(pos).isEmpty() && (!checkPass || pos!=pass)){
	    return ret;
	  }
	}
	return ret;
      }
      /**
       * ̾ζ5x3ΰͿƶ.
       * @param pass - ΰ֤stateʤǤȸʤ
       * @param state - ưξ
       * @param ptypeO - Υ
       * @param from - ΰ
       * @param kp - centering5x3ζ̤ΰ
       * @param pass - ΰ֤϶Ȥư
       */
      template<bool checkPass>
      inline int onBoardEffect(const NumEffectState& state,
				      PtypeO ptypeO, Position from, 
				      Position kp, 
				      Position pass=Position::STAND())
      {
	Offset32 offset32(kp,from);
	// ûˤ
	int ret=Effect5x3_Table.countShortEffect(ptypeO,offset32);
	// Ĺ
	LongEffect4 const& longEffect4=
	  Effect5x3_Table.getLongEffect(ptypeO,offset32);
	for(int i=0;i<4;i++){
	  Offset offset=longEffect4[i].offset;
	  if(offset.zero())break;
	  ret+=countLongEffect<checkPass>(state,from,offset,
					  longEffect4[i].minIndex,
					  longEffect4[i].maxIndex,pass);
	}
	return ret;
      }

      /**
       * blockˤ5x3ΰͿƶѲ.
       * @param state - ưξ
       * @param pl - Υץ쥤䡼
       * @param from - ưζΰ
       * @param to - ưζΰ
       * @param kp - centering5x3ζ̤ΰ
       */
      inline int blockingEffect(NumEffectState const& state,Player pl,
				       Position from, Position to, Position kp,
				       mask_t removeMask=mask_t())
      {
	mask_t eFrom=
	  state.getOnBoardMask(pl).getMask(PtypeFuns<ROOK>::indexNum) &
	  (state.getEffect(from).getMask(PtypeFuns<ROOK>::indexNum)>>8);
	mask_t eTo=
	  state.getOnBoardMask(pl).getMask(PtypeFuns<ROOK>::indexNum) &
	  (state.getEffect(to).getMask(PtypeFuns<ROOK>::indexNum)>>8);
	mask_t e3=(eFrom|eTo)&
	  mask_t::makeDirect(
			     PtypeFuns<ROOK>::indexMask |
			     PtypeFuns<BISHOP>::indexMask |
			     PtypeFuns<LANCE>::indexMask
			     ) & ~removeMask;
	int ret=0;
	while(!e3.none()){
	  int num1=e3.takeOneBit();
	  int num=num1+((PtypeFuns<ROOK>::indexNum)<<5);
	  Piece p=state.getPieceOf(num);
	  assert(p.isPiece());
	  assert(p.owner()==pl);
	  Position longPos=p.position();
	  Direction dFrom=
	    Board_Table.getLongDirection<BLACK>(Offset32(from,longPos));
	  Direction dTo=
	    Board_Table.getLongDirection<BLACK>(Offset32(to,longPos));
	  if(dFrom==dTo){
	    assert(dFrom!=0);
	    Direction d=longToShort(dFrom);
	    LongEffect const& blockEffectFrom=
	      Effect5x3_Table.getBlockEffect(d,Offset32(kp,from));
	    Offset offsetFrom=blockEffectFrom.offset;
	    if(!offsetFrom.zero()){
	      ret+=countLongEffect<true>(state,from,offsetFrom,
					 blockEffectFrom.minIndex,
					 blockEffectFrom.maxIndex,to);
	    }
	    LongEffect const& blockEffectTo=
	      Effect5x3_Table.getBlockEffect(d,Offset32(kp,to));
	    Offset offsetTo=blockEffectTo.offset;
	    if(!offsetTo.zero()){
	      ret-=countLongEffect<true>(state,to,offsetTo,
					 blockEffectTo.minIndex,
					 blockEffectTo.maxIndex,from);
	    }
	  }
	  else {
	    if((eFrom.value()&((mask_int_t)1<<num1))!=0){
	      assert(dFrom!=0);
	      Direction d=longToShort(dFrom);
	      LongEffect const& blockEffectFrom=
		Effect5x3_Table.getBlockEffect(d,Offset32(kp,from));
	      Offset offsetFrom=blockEffectFrom.offset;
	      if(!offsetFrom.zero()){
		ret+=countLongEffect<false>(state,from,offsetFrom,
					    blockEffectFrom.minIndex,
					    blockEffectFrom.maxIndex);
	      }
	    }
	    if((eTo.value()&((mask_int_t)1<<num1))!=0){
	      assert(dTo!=0);
	      Direction d=longToShort(dTo);
	      LongEffect const& blockEffectTo=
		Effect5x3_Table.getBlockEffect(d,Offset32(kp,to));
	      Offset offsetTo=blockEffectTo.offset;
	      if(!offsetTo.zero()){
		ret-=countLongEffect<false>(state,to,offsetTo,
					    blockEffectTo.minIndex,
					    blockEffectTo.maxIndex);
	      }
	    }
	  }
	}
	return ret;
      }

      /**
       * dropκݤblockˤ5x3ΰͿƶѲ.
       * @param state - ưξ
       * @param pl - Υץ쥤䡼
       * @param to - dropζΰ
       * @param kp - centering5x3ζ̤ΰ
       */
      inline int blockingEffect(NumEffectState const& state,Player pl,
				       Position to, Position kp, 
				       mask_t removeMask=mask_t())
      {
	mask_t e1=state.getOnBoardMask(pl).getMask(PtypeFuns<ROOK>::indexNum);
	mask_t e2=state.getEffect(to).getMask(PtypeFuns<ROOK>::indexNum)>>8;
	mask_t e3=e1 & e2 &mask_t::makeDirect(
					      PtypeFuns<ROOK>::indexMask |
					      PtypeFuns<BISHOP>::indexMask |
					      PtypeFuns<LANCE>::indexMask
					      ) &
	  ~removeMask;
	int ret=0;
	while(!e3.none()){
	  int num=e3.takeOneBit()+((PtypeFuns<ROOK>::indexNum)<<5);
	  Piece p=state.getPieceOf(num);
	  assert(p.isPiece());
	  assert(p.owner()==pl);
	  Position longPos=p.position();
	  Direction d=Board_Table.getLongDirection<BLACK>(Offset32(to,longPos));
	  assert(isLong(d));
	  d=longToShort(d);
	  LongEffect const& blockEffect=
	    Effect5x3_Table.getBlockEffect(d,Offset32(kp,to));
	  Offset offset=blockEffect.offset;
	  if(offset.zero()) continue;
	  ret-=countLongEffect<false>(state,to,offset,blockEffect.minIndex,
				      blockEffect.maxIndex);
	}
	return ret;
      }
    }
  }
}

void osl::progress::
Effect5x3d::doSimpleMove(const NumEffectState& state,
			Position from, Position to,  int promote_mask)
{
  Player pl0=state.getTurn();
  Player pl1=alt(pl0);
  Position kp0=Centering5x3::adjustCenter(state.getKingPosition(pl0));
  Position kp1=Centering5x3::adjustCenter(state.getKingPosition(pl1));
  Piece p=state.getPieceAt(from);
  PtypeO ptypeO0=p.ptypeO();
  PtypeO ptypeO1=promoteWithMask(ptypeO0,promote_mask);
  if(getPtype(ptypeO0)==KING &&
     Centering5x3::adjustCenter(from)!=Centering5x3::adjustCenter(to)){
    progresses[playerToIndex(pl0)]=makeProgress(pl0,state,to);
    assert(kp0==Centering5x3::adjustCenter(from));
    kp0=Centering5x3::adjustCenter(to);
  }
  // ι(Ĺû)
  // ̤5x3ˤĤ
  progresses[playerToIndex(pl0)]-=
    onBoardEffect<false>(state,ptypeO0,from,kp0);
  // ưι(Ĺû)
  // ̤5x3ˤĤ
  progresses[playerToIndex(pl0)]+=
    onBoardEffect<true>(state,ptypeO1,to,kp0,from);
  // ֥åκʬ
  // ξ5x3ˤĤ
  PieceMask pieceMask;
  // ʬȤ֥åĤˤʤ뤳Ȥ
  pieceMask.set(p.number());
  mask_t removeMask=pieceMask.getMask(PtypeFuns<ROOK>::indexNum);
  int val=blockingEffect(state,pl0,from,to,kp0,removeMask);
  progresses[playerToIndex(pl0)]+=val;
  progresses[playerToIndex(pl1)]+=blockingEffect(state,pl1,from,to,kp1);
}

void osl::progress::
Effect5x3d::doDropMove(const NumEffectState& state,Position to,Ptype ptype)
{
  Player pl0=state.getTurn();
  Player pl1=alt(pl0);
  Position kp0=Centering5x3::adjustCenter(state.getKingPosition(pl0));
  Position kp1=Centering5x3::adjustCenter(state.getKingPosition(pl1));
  PtypeO ptypeO=newPtypeO(pl0,ptype);
  // ưι(Ĺû)
  // ̤5x3ˤĤ
  progresses[playerToIndex(pl0)]+=onBoardEffect<false>(state,ptypeO,to,kp0);
  // ֥åκʬ
  // ξ5x3ˤĤ
  progresses[playerToIndex(pl0)]+=blockingEffect(state,pl0,to,kp0);
  progresses[playerToIndex(pl1)]+=blockingEffect(state,pl1,to,kp1);
}

void osl::progress::
Effect5x3d::doCaptureMove(const NumEffectState& state,
			 Position from, Position to, 
			 Piece victim,int promote_mask)
{
  Player pl0=state.getTurn();
  Player pl1=alt(pl0);
  Position kp0=Centering5x3::adjustCenter(state.getKingPosition(pl0));
  Position kp1=Centering5x3::adjustCenter(state.getKingPosition(pl1));
  Piece p=state.getPieceAt(from);
  PtypeO ptypeO0=p.ptypeO();
  PtypeO ptypeO1=promoteWithMask(ptypeO0,promote_mask);
  if(getPtype(ptypeO0)==KING &&
    Centering5x3::adjustCenter(from)!=Centering5x3::adjustCenter(to)){
    progresses[playerToIndex(pl0)]=makeProgress(pl0,state,to);
    assert(kp0==Centering5x3::adjustCenter(from));
    kp0=Centering5x3::adjustCenter(to);
  }
  // ι(Ĺû)
  // ̤5x3ˤĤ
  progresses[playerToIndex(pl0)]-=onBoardEffect<false>(state,ptypeO0,from,kp0);
  // ưι(Ĺû)
  // ̤5x3ˤĤ
  progresses[playerToIndex(pl0)]+=onBoardEffect<true>(state,ptypeO1,to,kp0,from);
  // captureι(Ĺ, û)
  // ̤5x3ˤĤ
  progresses[playerToIndex(pl1)]-=onBoardEffect<false>(state,victim.ptypeO(),to,kp1);
  // ֥åƤˤϽ
  // ֥å򤤤κʬ
  // ξ5x3ˤĤ
  progresses[playerToIndex(pl0)]-=blockingEffect(state,pl0,from,kp0);
  PieceMask pieceMask;
  pieceMask.set(state.getPieceAt(to).number());
  mask_t removeMask=pieceMask.getMask(PtypeFuns<ROOK>::indexNum);
  progresses[playerToIndex(pl1)]-=blockingEffect(state,pl1,from,kp1,removeMask);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
