/* plainNullWindowSearch.cc
 */
#include "osl/search/plainNullWindowSearch.h"
#include "osl/search/plainNullWindowSearch.tcc"
#include "osl/search/searchFramework.tcc"
#include "osl/eval/progressEval.h"
#ifdef USE_EACH_PLAYER_PROGRESS_PLAYER
#  include "osl/eval/eachPlayerAttackDefense.h"
#endif
#include "osl/eval/pieceEval.h"
#include "osl/category/standardMoveGenerator.h"

namespace osl
{
  template class search::PlainNullWindowSearch<eval::PieceEval,category::StandardMoveGenerator,
				       SimpleHashTable,CountRecorder,RealizationProbability>;
  template class search::PlainNullWindowSearch<eval::ProgressEval,category::StandardMoveGenerator,
				       SimpleHashTable,CountRecorder,RealizationProbability>;
#ifdef NEED_EXTRA_TEMPLATE_INSTANTIATION
  template bool search::PlainNullWindowSearch<eval::PieceEval, StandardMoveGenerator, SimpleHashTable, CountRecorder, RealizationProbability>::nullWindowSearch<BLACK, false>(SearchMove const&, int&, SearchMove&);
  template bool search::PlainNullWindowSearch<eval::PieceEval, StandardMoveGenerator, SimpleHashTable, CountRecorder, RealizationProbability>::nullWindowSearch<WHITE, false>(SearchMove const&, int&, SearchMove&);

  template bool search::PlainNullWindowSearch<eval::ProgressEval, StandardMoveGenerator, SimpleHashTable, CountRecorder, RealizationProbability>::nullWindowSearch<BLACK, false>(SearchMove const&, int&, SearchMove&);
  template bool search::PlainNullWindowSearch<eval::ProgressEval, StandardMoveGenerator, SimpleHashTable, CountRecorder, RealizationProbability>::nullWindowSearch<WHITE, false>(SearchMove const&, int&, SearchMove&);
#endif

  namespace search
  {
#ifdef USE_EACH_PLAYER_PROGRESS_PLAYER
    template class PlainNullWindowSearch<eval::EachPlayerAttackDefense,StandardMoveGenerator,
			SimpleHashTable,CountRecorder,RealizationProbability>;
#endif

    template class SearchFramework<PieceEval,StandardMoveGenerator,
			SimpleHashTable,CountRecorder,RealizationProbability>;
    template class SearchFramework<eval::ProgressEval,StandardMoveGenerator,
			SimpleHashTable,CountRecorder,RealizationProbability>;
#ifdef USE_EACH_PLAYER_PROGRESS_PLAYER
    template class SearchFramework<eval::EachPlayerAttackDefense,StandardMoveGenerator,
			SimpleHashTable,CountRecorder,RealizationProbability>;
#endif
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
