/* recordStack.cc
 */
#include "osl/search/recordStack.h"

osl::search::
RecordStack::RecordStack()
  : root_record(0)
{
  clear();
}

osl::search::
RecordStack::RecordStack(RecordStack const& r)
  : root_record(r.root_record)
{
  clear();
  assert(r.size()<=static_cast<size_t>(SEARCH_DEPTH_MAX));
  backup.push_back(0);
  for(size_t i=1;i<r.size();i++){
    if(r.data[i]!=0){
      backup.push_back(*(r.data[i]));
      assert(backup.size()==i+1);
      data.push_back( &backup[i] );
    }
    else{
      data.push_back(0);
      backup.push_back(0);
    }
  }
}

void osl::search::
RecordStack::clear()
{
  data.clear();
  push(&root_record); 
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
