/* legal_moves.cc
 */
#include "osl/state/numEffectState.h"
#include "osl/record/csa.h"
#include "osl/record/csaRecord.h"
#include "osl/container/moveVector.h"
#include "osl/move_generator/legalMoves.h"
#include "osl/apply_move/applyMove.h"
#include <iostream>
using namespace osl;

/**
 * @file ˡɽ
 */

int main(int argc, char **argv)
{
  NumEffectState state((SimpleState(HIRATE)));
  if (argc > 1)
  {
    const Record record = CsaFile(argv[1]).getRecord();
    state = NumEffectState(record.getInitialState());
    const vector<Move> moves=record.getMoves();
    for (vector<Move>::const_iterator p=moves.begin(); p!=moves.end(); ++p)
    {
      ApplyMoveOfTurn::doMove(state, *p);
    }
  }
  MoveVector moves;
  LegalMoves::generate(state, moves);
  std::cout << moves;
}



/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
