#include "osl/game_playing/gameState.h"
#include "osl/game_playing/mtdfPlayer.h"
#include "osl/game_playing/searchPlayer.tcc"
#include "osl/record/csaString.h"
#include "osl/misc/perfmon.h"
#include "osl/misc/random.h"
#include "osl/eval/progressEval.h"
#include "osl/search/parallelSearch.h"
#include <iostream>

using namespace osl;
using namespace osl::game_playing;

int main()
{
#ifdef OSL_SMP
  int search_limit=1200;
  int table_size=5000000;
  int check_table_size=5000000;
  int logMargin=0;
#if 0
  int record_limit=-5;
#else
  int record_limit=-16;
#endif
  int initial_limit = 400, deepening_step=200;
  int node_limit = 1600000;
  int seconds = 120;
  int nproc=4;
  osl::search::parallelSearch.setNumCPUs(nproc);
  GameState state(CsaString(
#if 0
			    "P1-KY-KE * -OU * +KA *  * -KY\n"
			    "P2 * -GI-KI *  * -GI-KI *  * \n"
			    "P3-FU *  * -FU-FU-FU-KE * -FU\n"
			    "P4 *  * -FU *  *  *  * -RY-KA\n"
			    "P5 *  *  * +GI *  * +FU *  * \n"
			    "P6 * +RY *  *  *  *  *  *  * \n"
			    "P7+FU * +KE+FU+FU+FU+KE * +FU\n"
			    "P8 *  * +KI * +OU+GI+KI+FU * \n"
			    "P9+KY *  *  *  *  *  *  * +KY\n"
			    "P+00FU00FU\n"
			    "P-00FU00FU00FU\n"
			    "+\n"
#else
			    "P1-KY-KE-GI-KI * -KI * -KE-KY\n"
			    "P2 *  * -OU *  *  * -GI *  * \n"
			    "P3-FU-FU-FU-FU-FU * -KA-FU-FU\n"
			    "P4 *  *  *  *  * -HI-FU *  * \n"
			    "P5 *  *  *  *  *  *  *  *  * \n"
			    "P6 *  * +FU *  *  * +FU *  * \n"
			    "P7+FU+FU * +FU+FU *  *  * +FU\n"
			    "P8 * +KA+OU * +KI+GI * +HI * \n"
			    "P9+KY+KE+GI+KI *  *  * +KE+KY\n"
			    "P+00FU00FU\n"
			    "P-00FU\n"
			    "+\n"
#endif
			    ).getInitialState());
  ProgressMtdfPlayer player;
  const char *pair_table_filename="../data/sibling-attack.pair";
  int load_success = eval::ProgressEval::setUp(pair_table_filename);
  if (! load_success)
  {
    std::cerr << pair_table_filename << " read error\n";
    return 1;
  }
  player.setVerbose();
  player.setDepthLimit(search_limit, initial_limit, deepening_step);
  player.setNodeLimit(node_limit);
  player.setTotalCheckmateLimit(check_table_size);
  player.setTableLimit(table_size, record_limit);
  {
    misc::PerfMon clock;
    const Move best_move = player.searchWithSecondsForThisMove(state, seconds).move; // Ȥ
    const unsigned long long cycles = clock.stop();
    std::cerr << cycles << std::endl;
    int depth = 0;

#if 0
    const unsigned int nodes 
      = recorder.nodeCount() + recorder.quiescenceCount();
    misc::PerfMon::message(cycles, "search ", nodes);
    misc::PerfMon::message(cycles, "search+checkmate ", 
			   nodes + recorder.checkmateCount());
#endif
  }
#endif  
}
