#include "osl/apply_move/applyMove.h"
#include "osl/state/numEffectState.h"
#include "osl/record/kisen.h"

#include <iostream>

void usage (const char *program_name)
{
  std::cerr << "Usage: " << program_name << " KISEN-FILE"
	    << std::endl;
  exit(1);
}

void check_all(const char*filename)
{
  osl::record::KisenFile kisen(filename);

  for (size_t i = 0; i < kisen.size(); i++)
  {
    std::cout << i << std::endl;
    const osl::vector<osl::Move> moves = kisen.getMoves(i);
    osl::state::NumEffectState state(kisen.getInitialState());

    for (size_t j = 0; j < moves.size(); j++)
    {
      const osl::Position opKingPosition 
	= state.getKingPosition(alt(state.getTurn()));
      if (state.hasEffectBy(state.getTurn(), opKingPosition))
      {
	break;
      }
      osl::apply_move::ApplyMoveOfTurn::doMove(state, moves[j]);
    }
  }
}

int main(int argc, char **argv)
{
  if (argc != 2)
    usage(argv[0]);

  check_all(argv[1]);

  return 0;
}
