#include "osl/category/defense.h"
#include "osl/category/categoryEnv.h"
#include "osl/record/csaString.h"
#include "osl/state/numEffectState.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;
using namespace osl::category;

class DefenseTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(DefenseTest);
  CPPUNIT_TEST(testAddSupport);
  CPPUNIT_TEST_SUITE_END();
public:
  void testAddSupport();
};

CPPUNIT_TEST_SUITE_REGISTRATION(DefenseTest);

void DefenseTest::testAddSupport()
{
  NumEffectState state(CsaString(
			 "P1-KY-KE-GI-KI-OU * -GI-KE-KY\n"
			 "P2 * -HI *  *  *  * -KI-KA * \n"
			 "P3-FU * -FU-FU-FU-FU-FU * -FU\n"
			 "P4 * -FU *  *  *  *  * -FU * \n"
			 "P5 *  *  *  *  *  *  *  *  * \n"
			 "P6 *  *  *  *  *  *  *  *  * \n"
			 "P7+FU+FU+FU+FU+FU+FU+FU * +FU\n"
			 "P8 * +KA *  *  *  *  * +HI * \n"
			 "P9+KY+KE+GI+KI+OU+KI+GI+KE+KY\n"
			 "P-00FU\n"
			 "-\n").getInitialState());
  CategoryEnv env(&state, 1000, 0);
  const Move m23ki = 
    Move(Position(3,2),Position(2,3),GOLD,PTYPE_EMPTY,false,WHITE);
  const std::pair<bool,size_t> result = AddSupport::getIndexIf(env, m23ki, 0);
  CPPUNIT_ASSERT(result.first);
  // AddSupport::probTable.show();
  const int prob = AddSupport::probTable[result.second];
  CPPUNIT_ASSERT(prob < 500);
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
