/* consistencyTest.h
 */
#ifndef TEST_EVAL_CONSISTENCYTEST_H
#define TEST_EVAL_CONSISTENCYTEST_H

#include "osl/state/numEffectState.h"
#include "osl/apply_move/applyMove.h"
#include "osl/record/csaString.h"
#include "osl/record/csaRecord.h"
#include <iostream>
#include <fstream>
#include <string>

#include <cppunit/extensions/HelperMacros.h>

template <class Eval>
void consistencyTest()
{
  using namespace osl;

  extern bool isShortTest;
  std::ifstream ifs(CSAFILES "/FILES");
  CPPUNIT_ASSERT(ifs);
  std::string file_name;
  for (int i=0;i<(isShortTest ? 10 : 900) && (ifs >> file_name) ; i++)
  {
    if ((i % 100) == 0)
      std::cerr << '.';
    if (file_name == "") 
      break;
    file_name = CSAFILES "/" + file_name;

    const Record record=CsaFile(file_name).getRecord();
    const vector<osl::Move> moves=record.getMoves();

    NumEffectState state(record.getInitialState());
    Eval eval(state);
    
    for (unsigned int i=0; i<moves.size(); i++)
    {
      const Move m = moves[i];
      ApplyMoveOfTurn::doMove(eval, state, m);
      ApplyMoveOfTurn::doMove(state, m);
      const Eval new_eval(state);
      if (new_eval.value() != eval.value()) {
	std::cerr << state << std::endl << m << std::endl;
      }
      CPPUNIT_ASSERT_EQUAL(new_eval.value(), eval.value());
    }
  }
}


#endif /* TEST_EVAL_CONSISTENCYTEST_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
