/* progressEval.t.cc
 */
#include "osl/eval/progressEval.h"
#include "osl/record/csaString.h"
#include "consistencyTest.h"

#include <cppunit/TestCase.h>

class ProgressEvalTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(ProgressEvalTest);
  CPPUNIT_TEST(testLoad);
  // ʹߤ testLoad θ˥ƥȤ뤳
  CPPUNIT_TEST(testBeginning);
  CPPUNIT_TEST(testConsistent);
  CPPUNIT_TEST_SUITE_END();
public:
  void testLoad();
  void testBeginning();
  void testConsistent();
};

CPPUNIT_TEST_SUITE_REGISTRATION(ProgressEvalTest);

using namespace osl;
using namespace osl::eval;
using namespace osl::eval::ppair;

void ProgressEvalTest::testBeginning()
{
  const NumEffectState state(CsaString(
			       "P1-KY-KE-GI-KI-OU-KI-GI-KE-KY\n"
			       "P2 * -HI *  *  *  *  * -KA * \n"
			       "P3-FU-FU-FU-FU-FU-FU-FU-FU-FU\n"
			       "P4 *  *  *  *  *  *  *  *  * \n"
			       "P5 *  *  *  *  *  *  *  *  * \n"
			       "P6 *  *  *  *  *  *  *  *  * \n"
			       "P7+FU+FU+FU+FU+FU+FU+FU+FU+FU\n"
			       "P8 * +KA *  *  *  *  * +HI * \n"
			       "P9+KY+KE+GI+KI+OU+KI+GI+KE * \n"
			       "P-00KY\n" // ɾͤ0ˤʤ
			       "+\n").getInitialState());
  ProgressEval eval(state);
  CPPUNIT_ASSERT_EQUAL(0, eval.progress16().value());
  ProgressEval::opening_eval_t opening(state);
  CPPUNIT_ASSERT(abs(opening.value()*16 - eval.value())
		 < ProgressEval::ROUND_UP);
}

void ProgressEvalTest::testLoad()
{
  CPPUNIT_ASSERT(ProgressEval::setUp());
}

void ProgressEvalTest::testConsistent()
{
  consistencyTest<ProgressEval>();
}


/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
