#include "osl/hash/hashKey.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;

class HashKeyTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(HashKeyTest);
  CPPUNIT_TEST(testPass);
  CPPUNIT_TEST_SUITE_END();
public:
  void testPass() { 
    const HashKey key;
    const HashKey key_black_pass = key.newHashWithMove(Move::PASS(BLACK));
    CPPUNIT_ASSERT(key != key_black_pass); 
    const HashKey key_white_pass = key.newHashWithMove(Move::PASS(WHITE));
    CPPUNIT_ASSERT(key != key_white_pass); 
  }
};

CPPUNIT_TEST_SUITE_REGISTRATION(HashKeyTest);

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
