#include "osl/ntesuki/idNtesukiRecord.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;
using namespace osl::ntesuki;

class IdNtesukiRecordTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE(IdNtesukiRecordTest);
  CPPUNIT_TEST(testGenerate);
  CPPUNIT_TEST(testModify);
  CPPUNIT_TEST_SUITE_END();
public:
  void testGenerate()
  {
    IdNtesukiRecord nr;

    for (int i = 0; i < IdNtesukiRecord::SIZE; ++i)
    {
      CPPUNIT_ASSERT_EQUAL(newIdNtesukiUnknown(0), nr[i]);
    }
  }

  void testModify()
  {
    IdNtesukiRecord nr;
    const IdNtesukiRecord& nrc = nr;

    nr[0] = NTESUKI_NO;
    CPPUNIT_ASSERT_EQUAL(NTESUKI_NO, nrc[0]);

    nr[1] = newIdNtesukiUnknown(10);
    CPPUNIT_ASSERT_EQUAL(newIdNtesukiUnknown(10), nrc[1]);

    nr[2] = NTESUKI_YES;
    CPPUNIT_ASSERT_EQUAL(NTESUKI_YES, nrc[2]);
  }

};

CPPUNIT_TEST_SUITE_REGISTRATION(IdNtesukiRecordTest);

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
