#include "osl/ntesuki/idNtesukiTable.h"
#include "osl/hash/hashKey.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;
using namespace osl::ntesuki;

class IdNtesukiTableTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(IdNtesukiTableTest);
  CPPUNIT_TEST(testCreation);
  CPPUNIT_TEST(testSize);
  CPPUNIT_TEST(testAllocate);
  CPPUNIT_TEST(testFind);
  CPPUNIT_TEST_SUITE_END();
public:
  void testCreation();
  void testSize();
  void testAllocate();
  void testFind();
};

void IdNtesukiTableTest::testCreation()
{
  IdNtesukiTable table(1,false);
}

void IdNtesukiTableTest::testSize()
{
  IdNtesukiTable table(1,false);
  CPPUNIT_ASSERT_EQUAL(0u, table.size());
}

void IdNtesukiTableTest::testAllocate()
{
  IdNtesukiTable table(100,false);
  HashKey k;
  CPPUNIT_ASSERT_EQUAL(0u, table.size());

  IdNtesukiRecord *record = table.allocate(k);
  CPPUNIT_ASSERT(record);
  CPPUNIT_ASSERT_EQUAL(1u, table.size());
}

void IdNtesukiTableTest::testFind()
{
  IdNtesukiTable table(100,false);
  HashKey k;
  CPPUNIT_ASSERT_EQUAL(0u, table.size());

  IdNtesukiRecord *record = table.allocate(k);

  IdNtesukiRecord *newrecord = table.find(k);
  CPPUNIT_ASSERT_EQUAL(record, newrecord);
}

CPPUNIT_TEST_SUITE_REGISTRATION(IdNtesukiTableTest);

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
