#include "osl/ntesuki/pdNtesukiRecord.h"
#include "osl/move.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;
using namespace osl::ntesuki;

class PdNtesukiRecordTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE(PdNtesukiRecordTest);
  CPPUNIT_TEST(testGenerate);
  CPPUNIT_TEST(testModify);
  CPPUNIT_TEST_SUITE_END();
public:
  void testGenerate()
  {
    PdNtesukiRecord nr(0u, HashKey());

    for (size_t i = 0; i < PdNtesukiRecord::SIZE; ++i)
    {
      CPPUNIT_ASSERT_EQUAL(ProofDisproof(1, 1), nr.getPdNtesukiResult(i));
    }
    CPPUNIT_ASSERT(!nr.isVisited());
    CPPUNIT_ASSERT(nr.needMoveGeneration());
    nr.moves.push_back(Move(Position(5,5), KNIGHT, WHITE));
    CPPUNIT_ASSERT(!nr.needMoveGeneration());
  }

  void testModify()
  {
    PdNtesukiRecord nr(0, HashKey());
    const PdNtesukiRecord& nrc = nr;

    nr.setPdNtesukiResult(0, ProofDisproof::NoCheckmate());
    CPPUNIT_ASSERT_EQUAL(ProofDisproof::NoCheckmate(), nrc.getPdNtesukiResult(0));

    nr.setPdNtesukiResult(1, ProofDisproof::Checkmate());
    CPPUNIT_ASSERT_EQUAL(ProofDisproof::Checkmate(), nrc.getPdNtesukiResult(1));
  }

};

CPPUNIT_TEST_SUITE_REGISTRATION(PdNtesukiRecordTest);

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
