#include "osl/ntesuki/pdNtesukiTable.h"
#include "osl/hash/hashKey.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;
using namespace osl::ntesuki;

class PdNtesukiTableTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(PdNtesukiTableTest);
  CPPUNIT_TEST(testCreation);
  CPPUNIT_TEST(testSize);
  CPPUNIT_TEST(testAllocate);
  CPPUNIT_TEST(testFind);
  CPPUNIT_TEST_SUITE_END();
public:
  void testCreation();
  void testSize();
  void testAllocate();
  void testFind();
};

void PdNtesukiTableTest::testCreation()
{
  PdNtesukiTable table(1,BLACK,false);
}

void PdNtesukiTableTest::testSize()
{
  PdNtesukiTable table(1,BLACK,false);
  CPPUNIT_ASSERT_EQUAL(0u, table.size());
}

void PdNtesukiTableTest::testAllocate()
{
  PdNtesukiTable table(100,BLACK,false);
  HashKey k;
  CPPUNIT_ASSERT_EQUAL(0u, table.size());

  PdNtesukiRecord *record = table.allocate(k, 0);
  CPPUNIT_ASSERT(record);
  CPPUNIT_ASSERT_EQUAL(1u, table.size());
}

void PdNtesukiTableTest::testFind()
{
  PdNtesukiTable table(100,BLACK,false);
  const HashKey k;
  CPPUNIT_ASSERT_EQUAL(0u, table.size());

  PdNtesukiRecord *record = table.allocate(k, 0);
  CPPUNIT_ASSERT(record);

  PdNtesukiRecord *newrecord = table.find(k);
  CPPUNIT_ASSERT(newrecord);
  CPPUNIT_ASSERT_EQUAL(record, newrecord);

  const HashKey kb = k.newHashWithMove(Move::PASS(BLACK));
  PdNtesukiRecord *brecord = table.allocate(kb, 0);
  CPPUNIT_ASSERT(brecord);
  CPPUNIT_ASSERT(record != brecord);
  CPPUNIT_ASSERT(newrecord != brecord);

  PdNtesukiRecord *newrecord2 = table.find(k);
  CPPUNIT_ASSERT_EQUAL(newrecord, newrecord2);
#if 0
  newrecord = table.find(k);
  CPPUNIT_ASSERT(!newrecord);
#endif
}

CPPUNIT_TEST_SUITE_REGISTRATION(PdNtesukiTableTest);

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
