#include "osl/search/searchMoveVector.h"
#include "osl/search/simpleHashRecord.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;
using namespace osl::search;

class SearchMoveVectorTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(SearchMoveVectorTest);
  // (ƥȤΤ)᥽åɤ󤹤롥
  CPPUNIT_TEST(testSort);
  CPPUNIT_TEST_SUITE_END();
public:
  void testSort();
};

CPPUNIT_TEST_SUITE_REGISTRATION(SearchMoveVectorTest);

void SearchMoveVectorTest::testSort()
{
  SimpleHashRecord record0;
  SimpleHashRecord record1;
  record0.setLowerBound(BLACK, 1, SearchMove(), 10);
  record1.setUpperBound(BLACK, 1, SearchMove(), 30);
  
  SearchMove m0(MoveLogProb(), &record0);
  SearchMove m1(MoveLogProb(), &record1);
  SearchMove m2((MoveLogProb()));

  SearchMoveVector v;
  v.push_back(&m0);
  v.push_back(&m1);
  v.push_back(&m2);

  v.sortByValue<BLACK>(0);
  CPPUNIT_ASSERT(v[0] == &m1);

  v.sortByValue<WHITE>(0);
  CPPUNIT_ASSERT(v[0] == &m2);

  v.sortByValue<BLACK>(100);
  CPPUNIT_ASSERT(v[0] == &m2);

  v.sortByValue<WHITE>(100);
  CPPUNIT_ASSERT(v[0] == &m0);
}


// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
